<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\EscopoManutService;

class EscopoManutController extends FMCrud{
    protected $dataSourceName = 'fcm_checklistagend';
    protected $EscopoManutService;
   
    public function __construct($crudService, $environment, EscopoManutService $EscopoManutService) {
        parent::__construct($crudService, $environment);
        $this->EscopoManutService = $EscopoManutService;
    }
    
    public function escopo(DTO\Request $request, DTO\Response $response) {
       $response->addDataSet(new DataSet('escopo', $this->EscopoManutService->escopo()));
    }
    
    public function rotaBase(DTO\Request $request, DTO\Response $response) {
        $method = $request->getMethod();
        $parametros = $request->getParameters();
        $escopo = '';

        if ($method== "POST") {
            $escopo = $this->EscopoManutService->inserirEscopo($parametros);

        } else if ($method == "GET") {
           $escopo = $this->EscopoManutService->getInformacoesEscopo();
        }

        $dtsVal = new DataSet('escopo', [$escopo]);
        $response->addDataSet($dtsVal);
    }

    public function excluirEscopo(DTO\Request $request, DTO\Response $response) {
        $parametro = $request->getParameters();

        $excluirEscopo = $this->EscopoManutService->excluirEscopo($parametro);
        $dtsVal = new DataSet('excluirEscopo', [$excluirEscopo]);
        $response->addDataSet($dtsVal);
    }

    public function editarEscopo(DTO\Request $request, DTO\Response $response) {

        $parametros = $request->getParameters();

        $escopo = $this->EscopoManutService->editarEscopo($parametros);
        $dtsVal = new DataSet('escopo', [$escopo]);
        $response->addDataSet($dtsVal);
    }

    public function getEscopo(DTO\Request $request, DTO\Response $response) {

        $parametros = $request->getParameters();

        $escopo = $this->EscopoManutService->getEscopo($parametros);
        $dtsVal = new DataSet('escopo', $escopo);
        $response->addDataSet($dtsVal);
    }
}

?>