<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\ListagemVistoriasService;

class ListagemVistoriasController extends FMCrud
{
    protected $dataSourceName = 'fcm_checklistagend';
    protected $ListagemVistoriasService;

    public function __construct($crudService, $environment, $ListagemVistoriasService) {
        parent::__construct($crudService, $environment);
        $this->ListagemVistoriasService = $ListagemVistoriasService;
    }

    // Funções da tela Lista de Tarefas

    // Função para setar os valores do select de local
    public function getPlaceSurvey(DTO\Request $request, DTO\Response $response) {

        $variavel = $this->ListagemVistoriasService->getPlaceSurvey();
        $dtsVal = new DataSet('place', $variavel);
        $response->addDataSet($dtsVal);
    }

    public function getEmployeeSurvey(DTO\Request $request, DTO\Response $response) {
        $parametro = $request->getParameters();

        $variavel = $this->ListagemVistoriasService->getEmployee($parametro);
        $dtsVal = new DataSet('employee', $variavel);
        $response->addDataSet($dtsVal);
    }

    public function getSituationSurvey(DTO\Request $request, DTO\Response $response) {

        $variavel = $this->ListagemVistoriasService->getSituation();
        $dtsVal = new DataSet('situation', $variavel);
        $response->addDataSet($dtsVal);
    }

    public function getCardsSurveys(DTO\Request $request, DTO\Response $response) {
        $parametro = $request->getParameters();

        $variavel = $this->ListagemVistoriasService->getCardsSurveys($parametro['filter'], $parametro['usersIds']);
        $dtsVal = new DataSet('cardsSurveys', $variavel);
        $response->addDataSet($dtsVal);
    }

    public function getDetailsSurvey(DTO\Request $request, DTO\Response $response) {

        $parametro = $request->getParameters();

        $variavel = $this->ListagemVistoriasService->getDetailsSurvey($parametro);
        $dtsVal = new DataSet('detailsSurvey', $variavel);
        $response->addDataSet($dtsVal);
    }

    // Funções da tela de Detalhes da Vistoria

    public function getTask(DTO\Request $request, DTO\Response $response) {
        $parametro = $request->getParameters();

        $variavel = $this->ListagemVistoriasService->getTask($parametro);
        $dtsVal = new DataSet('criterias', [$variavel]);
        $response->addDataSet($dtsVal);
    }

    public function upSurveyCriterias(DTO\Request $request, DTO\Response $response) {
        $parametro = $request->getParameters();
        
        $variavel = $this->ListagemVistoriasService->upSurveyCriterias($parametro[0],$parametro[1]);
        $dtsVal = new DataSet('upCriterias', [$variavel]);
        $response->addDataSet($dtsVal);
    }
}