<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\SolicitacaoServService;

class SolicitacaoServController extends FMCrud{
    protected $SolicitacaoServService;
   
    public function __construct($crudService, $environment, SolicitacaoServService $SolicitacaoServService) {
        parent::__construct($crudService, $environment);
        $this->SolicitacaoServService = $SolicitacaoServService;
    }
    
    public function listSolicitacaoServ(DTO\Request $request, DTO\Response $response) {
        $response->addDataSet(new DataSet('SolicitacaoServ', $this->SolicitacaoServService->listSolicitacaoServ($request->getParameters())));
    }
    
    public function listSolicitacaoServJoin(DTO\Request $request, DTO\Response $response) {
        $response->addDataSet(new DataSet('SolicitacaoServ', $this->SolicitacaoServService->listSolicitacaoServJoin($request->getParameters())));
    }
    
    public function recusarSolicitacao(DTO\Request $request, DTO\Response $response) {
        $response->addDataSet(new DataSet('SolicitacaoServ', $this->SolicitacaoServService->mudarStatus($request->getParameters())));
    }
}

?>