<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\UnidadeMedidaService;

class UnidadeMedidaController extends FMCrud{
    protected $UnidadeMedidaService;
   
    public function __construct($crudService, $environment, UnidadeMedidaService $UnidadeMedidaService) {
        parent::__construct($crudService, $environment);
        $this->UnidadeMedidaService = $UnidadeMedidaService;
    }
    
    public function unidadeMedida(DTO\Request $request, DTO\Response $response) {
        $response->addDataSet(new DataSet('unidadeMedida', $this->UnidadeMedidaService->getUnidadeMedida()));
    }
    
    public function rotaBase(DTO\Request $request, DTO\Response $response) {
        $method = $request->getMethod();
        $parametros = $request->getParameters();
        $unMedida = '';

        if ($method== "POST") {
            $unMedida = $this->UnidadeMedidaService->inserirUnidadeMedida($parametros);

        } else if ($method == "GET") {
           $unMedida = $this->UnidadeMedidaService->getInformacoesUnidadeMedida();
        }

        $dtsVal = new DataSet('unMedida', [$unMedida]);
        $response->addDataSet($dtsVal);
    }

    public function excluirUnidadeMedida(DTO\Request $request, DTO\Response $response) {
        $parametros = $request->getParameters();

        $excluirUni = $this->UnidadeMedidaService->excluirUnidadeMedida($parametros);
        $dtsVal = new DataSet('excluirUni', [$excluirUni]);
        $response->addDataSet($dtsVal);
    }

    public function getUnidadeMedidaEspecifica(DTO\Request $request, DTO\Response $response) {
        $parametros = $request->getParameters();

        $unidadeMedida = $this->UnidadeMedidaService->getUnidadeMedidaEspecifica($parametros);
        $dtsVal = new DataSet('unidadeMedida', $unidadeMedida);
        $response->addDataSet($dtsVal);
    }
    
    public function editarUnidadeMedida(DTO\Request $request, DTO\Response $response) {

        $parametros = $request->getParameters();

        $unidadeMedida = $this->UnidadeMedidaService->editarUnidadeMedida($parametros);
        $dtsVal = new DataSet('unidadeMedida', [$unidadeMedida]);
        $response->addDataSet($dtsVal);
    }
}

?>