<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class OrdemServFactory {
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function getOrdemServ($NR) {
        $alter="ALTER SESSION SET NLS_DATE_FORMAT = 'DD/MM/YYYY HH24:MI:SS'";
        $std = $this->connection->prepare($alter);
        $std->execute();

        $sql = "SELECT FCM_ORDEMSERV.NRORDEMSERV, TO_CHAR(FCM_ORDEMSERV.DTORDEMSERV, 'DD/MM/YYYY') AS DTORDEMSERV, FCM_TIPOMANUTENCAO.NMTIPOMANUTENCAO,
                       FCM_CATEGORIAMANUT.NMCATEGORIAMANUT,
                       CASE WHEN FCM_FUNCIONARIO.NMFUNCIONARIO IS NULL THEN ' ' ELSE FCM_FUNCIONARIO.NMFUNCIONARIO END AS NMFUNCIONARIO,
                       CASE FCM_ORDEMSERV.IDSITUACAO WHEN '1' THEN 'Pendente'
                                                        WHEN '2' THEN 'Em Andamento'
                                                     WHEN '3' THEN 'Concluída' END AS IDSITUACAO
                FROM FCM_ORDEMSERV
                JOIN FCM_CATEGORIAMANUT
                  ON FCM_ORDEMSERV.NRCATEGORIAMANUT = FCM_CATEGORIAMANUT.NRCATEGORIAMANUT
           left JOIN FCM_RESPONSAVEISORDEMSERV
                  ON FCM_ORDEMSERV.NRORDEMSERV = FCM_RESPONSAVEISORDEMSERV.NRORDEMSERV
           left JOIN FCM_FUNCIONARIO
                  ON FCM_RESPONSAVEISORDEMSERV.NRFUNCIONARIO = FCM_FUNCIONARIO.NRFUNCIONARIO
                JOIN FCM_TIPOMANUTENCAO
                  ON FCM_ORDEMSERV.NRTIPOMANUTENCAO = FCM_TIPOMANUTENCAO.NRTIPOMANUTENCAO
               WHERE FCM_ORDEMSERV.NREQUIPAMENTO = ".$NR;
            $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }

    public function listOrdemServ($params) {
        $sql = "SELECT NRORDEMSERV, DTORDEMSERV, IDSITUACAO, NREQUIPAMENTO,
                    NRCATEGORIAMANUT, NRTIPOMANUTENCAO, NRPRIORIDADEMANUT,
                    DSORDEMSERV, NMORDEMOSERV
                FROM FCM_ORDEMSERV";
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }

    public function getInformacoesOrdemServico() {

        $sql = "SELECT OSE.NRORDEMSERV, TO_CHAR(OSE.DTORDEMSERV, 'DD/MM') DTORDEMSERV, OSE.IDSITUACAO, EP.NMEQUIPAMENTO,
                CAT.NMCATEGORIAMANUT, TM.NMTIPOMANUTENCAO, P.NMPRIORIDADEMANUT, P.DSCORPRIORIDADE,
                  NVL((SELECT LISTAGG(FCM_FUNCIONARIO.NMFUNCIONARIO, ',')
                      WITHIN GROUP (ORDER BY FCM_RESPONSAVEISORDEMSERV.NRFUNCIONARIO)
                        FROM FCM_RESPONSAVEISORDEMSERV
                        JOIN FCM_FUNCIONARIO
                          ON FCM_RESPONSAVEISORDEMSERV.NRFUNCIONARIO = FCM_FUNCIONARIO.NRFUNCIONARIO
                       WHERE OSE.NRORDEMSERV = FCM_RESPONSAVEISORDEMSERV.NRORDEMSERV), ' ') NMFUNCIONARIO,
                 CASE OSE.IDSITUACAO WHEN '1' THEN 'Pendente'
                    WHEN '2' THEN 'Em Andamento'
                    WHEN '3' THEN 'Concluído'
                    ELSE NULL END AS NMIDSITUACAO
                 FROM FCM_ORDEMSERV OSE
                 JOIN FCM_PRIORIDADEMANUT P
                   ON P.NRPRIORIDADEMANUT = OSE.NRPRIORIDADEMANUT
                 JOIN FCM_EQUIPAMENTO EP
                   ON EP.NREQUIPAMENTO = OSE.NREQUIPAMENTO
                 JOIN FCM_CATEGORIAMANUT CAT
                   ON CAT.NRCATEGORIAMANUT = OSE.NRCATEGORIAMANUT
                 JOIN FCM_TIPOMANUTENCAO TM
                   ON TM.NRTIPOMANUTENCAO = OSE.NRTIPOMANUTENCAO";

        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }

    public function getOrdemServicoEspecifica($parametro) {

      $sql = " SELECT OSE.NRORDEMSERV, TO_CHAR(OSE.DTORDEMSERV, 'DD/MM/YY') DTORDEMSERV, OSE.IDSITUACAO, EP.NMEQUIPAMENTO,
                CAT.NMCATEGORIAMANUT, TM.NMTIPOMANUTENCAO, P.NMPRIORIDADEMANUT, P.DSCORPRIORIDADE, IMG.NRIMGORDEMSERV, IMG.DSCAMINHO,
                OSE.DSORDEMSERV, NVL(ES.NMESCOPOMANUT,'Não há escopo') NMESCOPOMANUT,
                  NVL((SELECT LISTAGG(FCM_FUNCIONARIO.NMFUNCIONARIO, ', ')
                      WITHIN GROUP (ORDER BY FCM_RESPONSAVEISORDEMSERV.NRFUNCIONARIO)
                        FROM FCM_RESPONSAVEISORDEMSERV
                        JOIN FCM_FUNCIONARIO
                          ON FCM_RESPONSAVEISORDEMSERV.NRFUNCIONARIO = FCM_FUNCIONARIO.NRFUNCIONARIO
                       WHERE OSE.NRORDEMSERV = FCM_RESPONSAVEISORDEMSERV.NRORDEMSERV), ' ') NMFUNCIONARIO,
                 CASE OSE.IDSITUACAO WHEN '1' THEN 'Pendente'
                    WHEN '2' THEN 'Em Andamento'
                    WHEN '3' THEN 'Concluído'
                    ELSE NULL END AS NMIDSITUACAO
                 FROM FCM_ORDEMSERV OSE
                 JOIN FCM_PRIORIDADEMANUT P
                   ON P.NRPRIORIDADEMANUT = OSE.NRPRIORIDADEMANUT
                 JOIN FCM_EQUIPAMENTO EP
                   ON EP.NREQUIPAMENTO = OSE.NREQUIPAMENTO
                 JOIN FCM_CATEGORIAMANUT CAT
                   ON CAT.NRCATEGORIAMANUT = OSE.NRCATEGORIAMANUT
                 JOIN FCM_TIPOMANUTENCAO TM
                   ON TM.NRTIPOMANUTENCAO = OSE.NRTIPOMANUTENCAO
            LEFT JOIN FCM_RELESCORDEMSERV REO
                   ON REO.NRORDEMSERV = OSE.NRORDEMSERV
            LEFT JOIN FCM_ESCOPOMANUT ES
                   ON ES.NRESCOPOMANUT = REO.NRESCOPOMANUT
            LEFT JOIN FCM_IMGORDEMSERV IMG
                   ON IMG.NRORDEMSERV = OSE.NRORDEMSERV
                WHERE OSE.NRORDEMSERV = :NRORDEMSERV";

        $std = $this->connection->prepare($sql);
        $std->execute($parametro);
        return $std->fetchAll();
    }

    public function comentariosOrdemServico($parametro) {

      $sql = "SELECT COS.NRCOMENTORDEMSERV, COS.NRORDEMSERV, COS.NRFUNCCOMENTARIO, TO_CHAR(COS.DTCOMENTARIO, 'DD/MM/YY HH24:MM') DTCOMENTARIO,
              COS.DSCOMENTARIO, F.NMFUNCIONARIO
                FROM FCM_COMENTORDEMSERV COS
                JOIN FCM_FUNCIONARIO F
                  ON F.NRFUNCIONARIO = COS.NRFUNCCOMENTARIO
                JOIN FCM_ORDEMSERV OS
                  ON OS.NRORDEMSERV = COS.NRORDEMSERV
               WHERE COS.NRORDEMSERV = :NRORDEMSERV
               ORDER BY COS.DTCOMENTARIO DESC, COS.NRCOMENTORDEMSERV DESC";

      $std = $this->connection->prepare($sql);
      $std->execute($parametro);
      return $std->fetchAll();

    }

    public function inserirComentarios($parametros) {

      $sql = "INSERT INTO FCM_COMENTORDEMSERV (NRCOMENTORDEMSERV, NRORDEMSERV, NRFUNCCOMENTARIO, DTCOMENTARIO, DSCOMENTARIO)
                VALUES (:NRCOMENTORDEMSERV, :NRORDEMSERV, :NRFUNCCOMENTARIO, SYSDATE, :DSCOMENTARIO)";

      $std = $this->connection->prepare($sql);
      $std->execute($parametros);
    }

    public function consultarRelacionamentoComSolicitacaoServico($parametro) {

      $sql = "SELECT RSS.NRRELSOLICITAORDEMSERV, RSS.NRSOLICITACAOSERV, RSS.NRORDEMSERV,
              TO_CHAR(SS.DTSOLICITACAOSERV, 'DD/MM/YY') DTSOLICITACAOSERV, IM.NMIMPACTOMANUT, FUNC.NMFUNCIONARIO
                FROM FCM_RELSOLICITAORDEMSERV RSS
                JOIN FCM_SOLICITACAOSERV SS
                  ON SS.NRSOLICITACAOSERV = RSS.NRSOLICITACAOSERV
                JOIN FCM_ORDEMSERV OS
                  ON OS.NRORDEMSERV = RSS.NRORDEMSERV
                JOIN FCM_IMPACTOMANUT IM
                  ON IM.NRIMPACTOMANUT = SS.NRIMPACTOMANUT
                JOIN FCM_FUNCIONARIO FUNC
                ON FUNC.NRFUNCIONARIO = SS.NRFUNCSOLICITANTE
               WHERE OS.NRORDEMSERV = :NRORDEMSERV";

      $std = $this->connection->prepare($sql);
      $std->execute($parametro);
      return $std->fetchAll();
    }

    public function inserirNovaOrdemServico($parametros) {

      $sql = "INSERT INTO FCM_ORDEMSERV (NRORDEMSERV, DTORDEMSERV, IDSITUACAO, NREQUIPAMENTO, NRCATEGORIAMANUT,
              NRTIPOMANUTENCAO, NRPRIORIDADEMANUT, DSORDEMSERV, DTINCLUSAO, IDFUNCEXTERNO, NMORDEMOSERV)

              VALUES (:NRORDEMSERV, TO_DATE(:DTORDEMSERV,'DD/MM/YYYY'), :IDSITUACAO, :NREQUIPAMENTO, :NRCATEGORIAMANUT, :NRTIPOMANUTENCAO,
              :NRPRIORIDADEMANUT, :DSORDEMSERV, SYSDATE, :IDFUNCEXTERNO, :NMORDEMOSERV)";

      $std = $this->connection->prepare($sql);
      $std->execute($parametros);
    }

    public function inserirFuncionarioResponsavel($parametros) {

      $sql = "INSERT INTO FCM_RESPONSAVEISORDEMSERV (NRRESPONSAVEISORDEMSERV, NRORDEMSERV, NRFUNCIONARIO, DTINCLUSAO)
              VALUES (:NRRESPONSAVEISORDEMSERV, :NRORDEMSERV, :NRFUNCIONARIO, SYSDATE)";

      $std = $this->connection->prepare($sql);
      $std->execute($parametros);
    }

    public function inserirEscopoRelacionado($parametros) {

      $sql = "INSERT INTO FCM_RELESCORDEMSERV (NRRELESCORDEMSERV, NRORDEMSERV, NRESCOPOMANUT, DTINCLUSAO)
              VALUES  (:NRRELESCORDEMSERV, :NRORDEMSERV, :NRESCOPOMANUT, SYSDATE)";

      $std = $this->connection->prepare($sql);
      $std->execute($parametros);
    }

    public function inserirImagensNovaOrdem($parametros) {

      $sql = "INSERT INTO FCM_IMGORDEMSERV (NRIMGORDEMSERV, NRORDEMSERV, DSCAMINHO, DTINCLUSAO, DSTYPE, NRSIZE, IDATIVO)
              VALUES (:NRIMGORDEMSERV, :NRORDEMSERV, :DSCAMINHO, SYSDATE, :DSTYPE, :NRSIZE, 'S')";

      $std = $this->connection->prepare($sql);
      $std->execute($parametros);
    }

    public function inserirRelacionamentoSoliOrdem($parametros) {

      $sql = "INSERT INTO FCM_RELSOLICITAORDEMSERV(NRRELSOLICITAORDEMSERV, NRSOLICITACAOSERV, NRORDEMSERV, IDATIVO, DTINCLUSAO)
              VALUES (:NRRELSOLICITAORDEMSERV, :NRSOLICITACAOSERV, :NRORDEMSERV, 'S', SYSDATE)";

      $std = $this->connection->prepare($sql);
      $std->execute($parametros);
    }

    public function getSolicitacaoServicoEspecifica($parametro) {

      $sql = "SELECT SS.NRSOLICITACAOSERV, TO_CHAR(SS.DTSOLICITACAOSERV, 'DD/MM/YY') DTSOLICITACAOSERV, SS.NRFUNCSOLICITANTE, SS.IDSITUACAO, SS.NREQUIPAMENTO, SS.NRCATEGORIAMANUT, SS.NRPRIORIDADEMANUT,
              SS.DSSOLICITACAOSERV, IM.NMIMPACTOMANUT, F.NMFUNCIONARIO, IMG.NRIMGSOLICITACAOSERV, IMG.DSCAMINHO, IMG.DSTYPE, IMG.NRSIZE
                       FROM FCM_SOLICITACAOSERV SS
                  LEFT JOIN FCM_IMPACTOMANUT IM
                         ON IM.NRIMPACTOMANUT = SS.NRIMPACTOMANUT
                  LEFT JOIN FCM_FUNCIONARIO F
                         ON F.NRFUNCIONARIO = SS.NRFUNCSOLICITANTE
                  LEFT JOIN FCM_IMGSOLICITACAOSERV IMG
                         ON IMG.NRSOLICITACAOSERV = SS.NRSOLICITACAOSERV
                      WHERE SS.NRSOLICITACAOSERV = :NRSOLICITACAOSERV";

      $std = $this->connection->prepare($sql);
      $std->execute($parametro);
      return $std->fetchAll();
    }

    public function listOrdemServJoin($params) {
        $sql = "SELECT ordServ.NRORDEMSERV, TO_CHAR(ordServ.DTORDEMSERV, 'DD/MM/YY') DTORDEMSERV,
                    ordServ.IDSITUACAO, ordServ.NREQUIPAMENTO,
                    ordServ.NRCATEGORIAMANUT, ordServ.NRTIPOMANUTENCAO,
                    ordServ.NRPRIORIDADEMANUT, ordServ.DSORDEMSERV,
                    ordServ.NMORDEMOSERV, equip.NMEQUIPAMENTO,
                    catManut.NMCATEGORIAMANUT, priorManut.NMPRIORIDADEMANUT,
                    func.NMFUNCIONARIO, tipManut.NMTIPOMANUTENCAO,
                    CASE ordServ.IDSITUACAO
                        WHEN '1' THEN 'Pendente'
                        WHEN '2' THEN 'Em Andamento'
                        WHEN '3' THEN 'Concluída'
                        ELSE NULL END AS STATUS
                FROM FCM_ORDEMSERV ordServ
                    INNER JOIN FCM_EQUIPAMENTO equip
                        ON ordServ.NREQUIPAMENTO = equip.NREQUIPAMENTO
                    INNER JOIN FCM_CATEGORIAMANUT catManut
                        ON ordServ.NRCATEGORIAMANUT = catManut.NRCATEGORIAMANUT
                    INNER JOIN FCM_PRIORIDADEMANUT priorManut
                        ON ordServ.NRPRIORIDADEMANUT = priorManut.NRPRIORIDADEMANUT
                    INNER JOIN FCM_RESPONSAVEISORDEMSERV resp
                        ON ordServ.NRORDEMSERV = resp.NRORDEMSERV
                    INNER JOIN FCM_FUNCIONARIO func
                        ON resp.NRFUNCIONARIO = func.NRFUNCIONARIO
                    INNER JOIN FCM_TIPOMANUTENCAO tipManut
                        ON ordServ.NRTIPOMANUTENCAO = tipManut.NRTIPOMANUTENCAO";
        $whereClausule = $this->concatWhereClausule($params);
        $sql .= $whereClausule;
        $std = $this->connection->prepare($sql);
        if (strlen($whereClausule) > 0) {
            $std->execute($params);
        } else {
            $std->execute();
        }
        return $std->fetchAll();
    }

    protected function concatWhereClausule($params) {
        $useParams = false;
        $paramKeys = array_keys($params);
        $query = "";
        $mainTable = "solServ";
        foreach($paramKeys as $key) {
            if (!$useParams) {
                $useParams = true;
                $query.= " WHERE ";
            } else {
                $query.= " AND ";
            }
            $query.= $mainTable . "." . $key . " = :" . $key;
        }
        return $query;
    }
}

?>