<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class SolicitacaoServFactory {
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    public function listSolicitacaoServ($params) {
        $sql = "SELECT NRSOLICITACAOSERV, DTSOLICITACAOSERV, NRFUNCSOLICITANTE,
                    IDSITUACAO, NREQUIPAMENTO, NRCATEGORIAMANUT,
                    NRIMPACTOMANUT, NRPRIORIDADEMANUT, DSSOLICITACAOSERV,
                    NMSOLICITACAOSERV
                FROM FCM_SOLICITACAOSERV";
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }

    public function listSolicitacaoServJoin($params) {
        $sql = "SELECT solServ.NRSOLICITACAOSERV, TO_CHAR(solServ.DTSOLICITACAOSERV, 'DD/MM/YY') AS DTSOLICITACAOSERV, catManut.NMCATEGORIAMANUT, equip.NMEQUIPAMENTO,
                    solServ.DSSOLICITACAOSERV, func.NMFUNCIONARIO,
                    solServ.NRFUNCSOLICITANTE, solServ.IDSITUACAO,
                    solServ.NREQUIPAMENTO, solServ.NRCATEGORIAMANUT,
                    solServ.NRIMPACTOMANUT, impManut.NMIMPACTOMANUT, solServ.NRPRIORIDADEMANUT, solServ.NMSOLICITACAOSERV,
                    (SELECT LISTAGG(FCM_IMGSOLICITACAOSERV.DSCAMINHO, ', ') WITHIN GROUP (ORDER BY FCM_IMGSOLICITACAOSERV.DSCAMINHO)
                       FROM FCM_IMGSOLICITACAOSERV
                      WHERE solServ.NRSOLICITACAOSERV = FCM_IMGSOLICITACAOSERV.NRSOLICITACAOSERV) AS DSCAMINHO,
                    (SELECT LISTAGG(escManut.NRESCOPOMANUT, ', ') WITHIN GROUP (ORDER BY escManut.NRESCOPOMANUT)
                       FROM FCM_RELESCSOLICITASERV relEscoSol
                       JOIN FCM_ESCOPOMANUT escManut
                         ON relEscoSol.NRESCOPOMANUT = escManut.NRESCOPOMANUT
                      WHERE solServ.NRSOLICITACAOSERV = relEscoSol.NRSOLICITACAOSERV) AS NRESCOPOMANUT,
                    CASE solServ.IDSITUACAO
                        WHEN '1' THEN 'Pendente'
                        WHEN '2' THEN 'Em Andamento'
                        WHEN '3' THEN 'Aguardando vistoria'
                        WHEN '4' THEN 'Concluída'
                        ELSE NULL
                    END AS IDSITUACAO
                FROM FCM_SOLICITACAOSERV solServ
                INNER JOIN FCM_EQUIPAMENTO equip
                    ON solServ.NREQUIPAMENTO = equip.NREQUIPAMENTO
                INNER JOIN FCM_CATEGORIAMANUT catManut
                    ON solServ.NRCATEGORIAMANUT = catManut.NRCATEGORIAMANUT
                INNER JOIN FCM_FUNCIONARIO func
                    ON solServ.NRFUNCSOLICITANTE = func.NRFUNCIONARIO
                  JOIN FCM_IMPACTOMANUT impManut
                    ON solServ.NRIMPACTOMANUT = impManut.NRIMPACTOMANUT";
        $whereClausule = $this->concatWhereClausule($params);
        $sql .= $whereClausule;
        $std = $this->connection->prepare($sql);
        if (strlen($whereClausule) > 0) {
            $std->execute($params);
        } else {
            $std->execute();
        }
        return $std->fetchAll();
    }

    protected function concatWhereClausule($params) {
        $useParams = false;
        $paramKeys = array_keys($params);
        $query = "";
        $mainTable = "solServ";
        foreach($paramKeys as $key) {
            if (!$useParams) {
                $useParams = true;
                $query.= " WHERE ";
            } else {
                $query.= " AND ";
            }
            $query.= $mainTable . "." . $key . " = :" . $key;
        }
        return $query;
    }

    public function mudarStatus($params) {
        $sql = "UPDATE FCM_SOLICITACAOSERV
                   SET IDSITUACAO = 1
                 WHERE NRSOLICITACAOSERV = :NRSOLICITACAOSERV";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
}

?>