<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class UnidadeMedidaFactory {
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function getUnidadeMedida() {
        $sql = "SELECT NRUNIDADEMEDIDA, NMUNIDADEMEDIDA
                  FROM FCM_UNIDADEMEDIDA";
        
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
    
    public function inserirUnidadeMedida($parametros) {

        $sql = "INSERT INTO FCM_UNIDADEMEDIDA(NRUNIDADEMEDIDA,NMUNIDADEMEDIDA, NRORG, DTINCLUSAO, NMABREVUNIDADEMEDIDA)
                    VALUES (:NRUNIDADEMEDIDA, :NMUNIDADEMEDIDA, :NRORG, SYSDATE, :NMABREVUNIDADEMEDIDA)";

        $std = $this->connection->prepare($sql);
        $std->execute($parametros);
    }

    public function getInformacoesUnidadeMedida() {

        $sql = "SELECT NRUNIDADEMEDIDA, NMUNIDADEMEDIDA, NMABREVUNIDADEMEDIDA
                    FROM FCM_UNIDADEMEDIDA";

        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }

    public function getUnidadeMedidaEspecifica($parametro) {

        $sql = "SELECT NRUNIDADEMEDIDA, NMUNIDADEMEDIDA, NMABREVUNIDADEMEDIDA
                    FROM FCM_UNIDADEMEDIDA
                    WHERE NRUNIDADEMEDIDA = :NRUNIDADEMEDIDA";

        $std = $this->connection->prepare($sql);
        $std->execute($parametro);
        return $std->fetchAll();
    }

    public function deletarUnidadeMedida($parametro) {

        $sql = "DELETE FROM FCM_UNIDADEMEDIDA
                    WHERE NRUNIDADEMEDIDA = :NRUNIDADEMEDIDA";

        $std = $this->connection->prepare($sql);
        $std->execute($parametro);
    }
    
    public function updateUnidadeMedida($parametros) {
        
        $sql = "UPDATE FCM_UNIDADEMEDIDA
                        SET NMUNIDADEMEDIDA = :NMUNIDADEMEDIDA,
                            NMABREVUNIDADEMEDIDA = :NMABREVUNIDADEMEDIDA
                        WHERE NRUNIDADEMEDIDA = :NRUNIDADEMEDIDA";
        
        $std = $this->connection->prepare($sql);
        $std->execute($parametros);
    }
}

?>