<?php

namespace FM\Service;

use FM\Factory\EscopoManutFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class EscopoManutService {

    protected $EscopoManutFactory;
    protected $Environment;
    protected $newCode;

    public function __construct (EntityManager $entityManager, EscopoManutFactory $EscopoManutFactory, Environment $Environment, NewCode $newCode) {
        $this->EscopoManutFactory = $EscopoManutFactory;
        $this->connection         = $entityManager->getConnection();
        $this->Environment        = $Environment;
        $this->newCode            = $newCode;
    }

    public function escopo(){
        return $this->EscopoManutFactory->escopo();
    }

    public function inserirEscopo($parametros) {
        $NRORG = 20;
        $this->connection->beginTransaction();

        try {

            $NRESCOPOMANUT = $this->newCode->getCodeByTableName("FCM_ESCOPOMANUT", $NRORG, 1, 10, true);

            $parametrosEscopo = array(
              "NRESCOPOMANUT" => $NRESCOPOMANUT,
              "NMESCOPOMANUT" => $parametros['NMESCOPOMANUT'],
              "NRORG"         => $NRORG
            );

            $this->EscopoManutFactory->inserirEscopo($parametrosEscopo);

            $this->connection->commit();
            $response = 'OK';

        } catch(\Exception $e) {
          $this->connection->rollback();
          $response = ($e->getMessage());
      }
       return $response;
    }

    public function getInformacoesEscopo() {

        $escopo = $this->EscopoManutFactory->getInformacoesEscopo();
        return $escopo;
    }

    public function excluirEscopo($parametro) {

        $this->connection->beginTransaction();

        try {

            $param = array(
                'NRESCOPOMANUT' => $parametro['NRESCOPOMANUT']
            );

            $this->EscopoManutFactory->deletarEscopo($param);

            $this->connection->commit();
            $response = 'OK';

      } catch(\Exception $e) {
          $this->connection->rollback();
          $response = ($e->getMessage());
      }
       return $response;
    }

    public function getEscopo($parametro) {

        $param = array(
         "NRESCOPOMANUT" => $parametro['NRESCOPOMANUT']
        );

        $infoTipo = $this->EscopoManutFactory->getEscopo($param);
        return $infoTipo;
    }

    public function editarEscopo($parametros) {
        $this->connection->beginTransaction();

        try {

            $parametrosEscopo = array(
                "NRESCOPOMANUT"  => $parametros['NRESCOPOMANUT'],
                "NMESCOPOMANUT"  => $parametros['NMESCOPOMANUT'],
            );

            $this->EscopoManutFactory->updateEscopo($parametrosEscopo);

            $this->connection->commit();
            $response = 'OK';

      } catch(\Exception $e) {
          $this->connection->rollback();
          $response = ($e->getMessage());
      }
       return $response;

    }
}

?>