<?php

namespace FM\Service;

use FM\Factory\SolicitacaoServFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use FM\Factory\ComentSolicitServFactory;
use Doctrine\ORM\EntityManager;

class SolicitacaoServService {

    protected $SolicitacaoServFactory;
    protected $Environment;
    protected $newCode;
    protected $ComentSolicitServFactory;
    protected $connection;

    public function __construct (SolicitacaoServFactory $SolicitacaoServFactory, Environment $Environment, NewCode $newCode, ComentSolicitServFactory $ComentSolicitServFactory, EntityManager $entityManager) {
        $this->SolicitacaoServFactory = $SolicitacaoServFactory;
        $this->Environment = $Environment;
        $this->newCode = $newCode;
        $this->ComentSolicitServFactory = $ComentSolicitServFactory;
        $this->connection = $entityManager->getConnection();
    }
    
    public function listSolicitacaoServ($params) {
        $solicitacoes = $this->SolicitacaoServFactory->listSolicitacaoServ($params);
        return $solicitacoes;
    }
    
    public function listSolicitacaoServJoin($params) {
        $solicitacoes = $this->SolicitacaoServFactory->listSolicitacaoServJoin($params);
        return $solicitacoes;
    }
    
    public function mudarStatus($param) {
        $this->connection->beginTransaction();
        
        try {
            $this->SolicitacaoServFactory->mudarStatus(array("NRSOLICITACAOSERV" => intval($param['NRSOLICITACAOSERV'])));
            
            $this->ComentSolicitServFactory->postComentarios(array(
            "NRCOMENTSOLICITSERV" => $this->newCode->getCodeByTableName("FCM_COMENTSOLICITSERV", 20, 1, 10, true),
            "NRSOLICITACAOSERV" => intval($param['NRSOLICITACAOSERV']),
            "NRFUNCCOMENTARIO" => intval($param['NRFUNCCOMENTARIO']),
            "DTCOMENTARIO" => $param['DTCOMENTARIO'],
            "DSCOMENTARIO" => $param['DSCOMENTARIO'],
            "NRORG" => 20 
        ));
            
            $this->connection->commit();
            $response = "OK";
        } catch(\Exception $e) {
            $this->connection->rollback();
            $response = ($e->getMessage());
        }
        return [$response];
    }
}

?>