<?php

namespace FM\Service;

use FM\Factory\UnidadeMedidaFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class UnidadeMedidaService {

    protected $UnidadeMedidaFactory;
    protected $Environment;
    protected $newCode;

    public function __construct (EntityManager $entityManager, UnidadeMedidaFactory $UnidadeMedidaFactory, Environment $Environment, NewCode $newCode) {
        $this->UnidadeMedidaFactory = $UnidadeMedidaFactory;
        $this->connection           = $entityManager->getConnection();
        $this->Environment          = $Environment;
        $this->newCode              = $newCode;
    }
    
    public function getUnidadeMedida(){
        return $this->UnidadeMedidaFactory->getUnidadeMedida();;
    }

    public function inserirUnidadeMedida($parametros) {
        $NRORG = 20;
        $this->connection->beginTransaction();

        try {

            $NRUNIDADEMEDIDA = $this->newCode->getCodeByTableName("FCM_UNIDADEMEDIDA", $NRORG, 1, 10, true);

            $parametrosUni = array(
              "NRUNIDADEMEDIDA"      => $NRUNIDADEMEDIDA,
              "NMUNIDADEMEDIDA"      => $parametros['NMUNIDADEMEDIDA'],
              "NMABREVUNIDADEMEDIDA" => $parametros['NMABREVUNIDADEMEDIDA'],
              "NRORG"                => $NRORG
            );

            $this->UnidadeMedidaFactory->inserirUnidadeMedida($parametrosUni);

            $this->connection->commit();
            $response = 'OK';

        } catch(\Exception $e) {
          $this->connection->rollback();
          $response = ($e->getMessage());
      }
       return $response;
    }

    public function getInformacoesUnidadeMedida() {

        $uni = $this->UnidadeMedidaFactory->getInformacoesUnidadeMedida();
        return $uni;
    }

    public function excluirUnidadeMedida($parametro) {

        $this->connection->beginTransaction();

        try {

            $param = array(
                'NRUNIDADEMEDIDA' => $parametro['NRUNIDADEMEDIDA']
            );

            $this->UnidadeMedidaFactory->deletarUnidadeMedida($param);

            $this->connection->commit();
            $response = 'OK';

      } catch(\Exception $e) {
          $this->connection->rollback();
          $response = ($e->getMessage());
      }
       return $response;
    }

    public function getUnidadeMedidaEspecifica($parametro) {

        $param = array(
                'NRUNIDADEMEDIDA' => $parametro['NRUNIDADEMEDIDA']
            );

        $uni = $this->UnidadeMedidaFactory->getUnidadeMedidaEspecifica($param);
        return $uni;
    }

    public function editarUnidadeMedida($parametros) {

        $this->connection->beginTransaction();

        try {

            $parametrosUni = array(
              "NRUNIDADEMEDIDA"      => $parametros['NRUNIDADEMEDIDA'],
              "NMUNIDADEMEDIDA"      => $parametros['NMUNIDADEMEDIDA'],
              "NMABREVUNIDADEMEDIDA" => $parametros['NMABREVUNIDADEMEDIDA'],
            );

            $this->UnidadeMedidaFactory->updateUnidadeMedida($parametrosUni);

            $this->connection->commit();
            $response = 'OK';

      } catch(\Exception $e) {
          $this->connection->rollback();
          $response = ($e->getMessage());
      }
       return $response;
    }
}

?>