/*

@C:\web_511\sql\end_conv\oracle\9341_CVISTPO_ETL_MERENDA.SQL


- Erro     : raise_application_error(-20501, 'Mensagem', True);
*/
CREATE OR REPLACE PROCEDURE ETL_MERENDA
                          (P_DTINI      IN DATE,  
                           P_DTFINA     IN DATE)  
IS  
   V_COUNTER       NUMBER       NOT NULL := 0;  
   V_DTFIM         DATE;  
   V_DTINI         DATE;  
     
   V_NRTIPOCUSTO1    NUMBER;  
   V_NRTIPOCUSTO2    NUMBER;     
   V_NRTIPOCUSTO3    NUMBER; 
    
   V_VRCUSTPADR      FLOAT NOT NULL := 0;    
   V_ZERO            FLOAT := 0;    
   V_CDSEQUENCIAL    VARCHAR2(20);
   V_COUNTTPCUST     FLOAT := 0;

   V_MES           VARCHAR2(02);  
   V_ANO           VARCHAR2(04);     
   V_BIM           VARCHAR2(06);  
   V_TRI           VARCHAR2(06);  
   V_SEM           VARCHAR2(06);

   w_S             CHAR := 'S';
   w_N             CHAR := 'N';
        
BEGIN 

   V_MES  :=  TO_CHAR(P_DTINI,'MM');  
   V_ANO  :=  TO_CHAR(P_DTINI,'YYYY');     
    
   DELETE FROM ETL_RESUSERV  
   WHERE (CDANOBI > V_ANO)
      OR (CDANOBI = V_ANO AND CDMESBI >= V_MES);
   COMMIT;

   DELETE FROM ETL_RESUFOOD
   WHERE (CDANOBI > V_ANO)
      OR (CDANOBI = V_ANO AND CDMESBI >= V_MES);
   COMMIT;

  /* IF NOT CUSTO DIMENSAO*/
   /*ANALIZA SE EXISTE TPCUST CADASTRADO NA TABELA DIMENSAODW */
   SELECT
    COUNT(*)
   INTO
    V_COUNTTPCUST
   FROM
    DIMENSAODW
   WHERE
    CDTABELADW = 'ETL_RESUFOOD'
    AND CDITEMDIME = 'CDTIPOCUSTO';

  IF V_COUNTTPCUST = 0 THEN

   FOR C_NRTPCUS IN
      (SELECT ROWNUM AS LINHA, NRTIPOCUSTO
       FROM(SELECT TO_NUMBER(CDTIPOCUSTO) NRTIPOCUSTO
       FROM   TIPOCUSTO
       WHERE IDTPCUSTOGSC = 'S'
       ORDER BY NRTIPOCUSTO)
       )
   LOOP
      IF C_NRTPCUS.LINHA    = 1 THEN
         V_NRTIPOCUSTO1    := C_NRTPCUS.NRTIPOCUSTO;
      ELSIF C_NRTPCUS.LINHA = 2 THEN
         V_NRTIPOCUSTO2    := C_NRTPCUS.NRTIPOCUSTO;
      ELSIF C_NRTPCUS.LINHA = 3 THEN
         V_NRTIPOCUSTO3    := C_NRTPCUS.NRTIPOCUSTO;
      END IF;

   END LOOP;

   V_DTINI := ADD_MONTHS(LAST_DAY(P_DTINI) + 1, -1);

   WHILE (V_DTINI  <=  P_DTFINA) LOOP
      V_DTFIM      :=   LAST_DAY( V_DTINI);
      V_MES        :=   TO_CHAR(V_DTFIM,'MM');
      V_ANO        :=   TO_CHAR(V_DTFIM,'YYYY');
      V_BIM        :=   TO_CHAR(TRUNC((V_MES - 1) / 2) + 1)||' Bim';
      V_TRI        :=   TO_CHAR(TRUNC((V_MES - 1) / 3) + 1)||' Tri';
      V_SEM        :=   TO_CHAR(TRUNC((V_MES - 1) / 6) + 1)||' Sem';

      FOR C_ETL IN
         (SELECT FL.CDFILIAL,        FL.CDAREAGERE,          FL.DTINICIALBI,
                 FL.CDSUPERVISOR,    FL.CDGOPERAC,           FL.CDEMPRESA,
                 FL.CDSEGMER , FL.CDFILCENTPME
            FROM FILIAL FL, PARAMFILIAL P
           WHERE P.CDFILIAL = FL.CDFILIAL
             AND FL.IDFUNCAOFILI IS NULL
             AND FL.DTINICIALBI  IS NOT NULL
            and nvl(IDCTRLESTQ, w_S) <> w_N
            AND NVL(IDCNTRRESC, w_N) <> w_S
            ORDER BY FL.CDFILIAL )      LOOP

         IF ADD_MONTHS(LAST_DAY(C_ETL.DTINICIALBI) + 1, -1) <= V_DTINI THEN

            NOVO_CODIGO('CONSPLAN'||C_ETL.CDFILIAL, V_CDSEQUENCIAL,1);
            V_CDSEQUENCIAL := SUBSTR(V_CDSEQUENCIAL,11,10);


            CONSUMO_PLANEJADO_PLA(
                                  C_ETL.CDFILIAL,
                                  'T',
                                  V_DTINI,
                                  V_DTFIM,
                                  'T',
                                  'CFP',
                                  'N',
                                   0,
                                  'N',
                                   V_CDSEQUENCIAL,
                                  '0',
                                  'zzzzzzzzzz',
                                  '',
                                  '_'||TO_CHAR(V_DTINI, 'YYYYMMDD')||'_',
                                  '_'||TO_CHAR(V_DTFIM, 'YYYYMMDD')||'_'
                                  );

            FOR C_SERVICO IN
               (SELECT
                      SE.CDSERVFILI,                 SE.CDGRUPSERV,
                      SUM(SE.QTCOMESTICAR / TOTAL) AS QTCOMESTICAR,
                      SUM(SE.QTCOMEFETCAR / TOTAL) AS QTCOMEFETCAR
                 FROM (SELECT
                            CP.DTCONSPLAN DTCARDAPIO,
                            SRV.CDSERVFILI, GS.CDGRUPSERV,
                            SUM(CAR.QTCOMESTICAR) QTCOMESTICAR,
                            SUM(CAR.QTCOMEFETCAR) QTCOMEFETCAR,
                            COUNT(*) AS TOTAL
                       FROM SERVICO SRV,   CARDADIA CAR, GRUPSERV GS,   CONSPLAN CP
                       WHERE  CAR.CDFILIAL       =   SRV.CDFILIAL
                        AND CAR.CDSERVFILI     =   SRV.CDSERVFILI
                        AND SRV.CDFILIAL       =   C_ETL.CDFILIAL
                        AND CAR.DTCARDAPIO BETWEEN V_DTINI AND V_DTFIM
                        AND GS.CDGRUPSERV (+)  =   SRV.CDGRUPSERV
                        AND CP.CDFILICPLA      =   C_ETL.CDFILIAL
                        AND CP.CDSERVCPLA      =   SRV.CDSERVFILI
                        AND CP.DTCONSPLAN      =   CAR.DTCARDAPIO
                        AND CP.NRCONSPLAN      =   V_CDSEQUENCIAL
                      GROUP BY CP.DTCONSPLAN, SRV.CDSERVFILI,  SRV.CDFILIAL,  GS.CDGRUPSERV

                      UNION ALL

                       SELECT
                            CAR.DTCARDAPIO,
                            SRV.CDSERVFILI, GS.CDGRUPSERV,
                            NVL(SUM(CAR.QTCOMESTICAR), 0) QTCOMESTICAR,
                            NVL(SUM(CAR.QTCOMEFETCAR), 0) QTCOMEFETCAR,
                            COUNT(*) AS TOTAL
                       FROM SERVICO SRV,   CARDADIA CAR, GRUPSERV GS
                       WHERE CAR.CDFILIAL       =   SRV.CDFILIAL
                        AND CAR.CDSERVFILI     =   SRV.CDSERVFILI
                        AND SRV.CDFILIAL       =   C_ETL.CDFILIAL
                        AND CAR.DTCARDAPIO BETWEEN V_DTINI AND V_DTFIM
                        AND GS.CDGRUPSERV (+)  =   SRV.CDGRUPSERV
                        AND CAR.QTCOMESTICAR = 0
                        AND CAR.CDSERVFILI  NOT IN (SELECT CDSERVCPLA
                                                     FROM CONSPLAN CP
                                                   WHERE  CP.DTCONSPLAN BETWEEN V_DTINI AND V_DTFIM
                                                     AND  CP.DTCONSPLAN = CAR.DTCARDAPIO
                                                     AND  CP.NRCONSPLAN = V_CDSEQUENCIAL
                                                     AND  CP.CDFILICPLA = C_ETL.CDFILIAL)
                      GROUP BY CAR.DTCARDAPIO,SRV.CDSERVFILI, SRV.CDFILIAL, GS.CDGRUPSERV

                      UNION ALL
                                      /*QUANTIDADE PLANEJADA MERENDA*/
                      SELECT
                             CD.DTCARDAPIO,
                             SRV.CDSERVFILI, GS.CDGRUPSERV,
                             SUM(CD.QTCOMESTICAR) QTCOMESTICAR,
                             SUM(QTCLIESTICAR) QTCOMEFETCAR,
                             COUNT(*) AS TOTAL
                        FROM SERVICO SRV,    GRUPSERV GS,  CONSPLAN CP,
                             (SELECT  CDFILCENTPME, CDFILIAL, CDSERVFILI, DTCARDIAPME DTCARDAPIO, NRCARDPME,
                                SUM(QTCOMESTCPME) QTCOMESTICAR, SUM(QTCLIESTCPME) QTCLIESTICAR
                              FROM CARDIAPME
                              WHERE
                                 CDFILCENTPME = C_ETL.CDFILIAL  AND
                                 CDFILIAL = C_ETL.CDFILIAL  AND
                                (DTCARDIAPME BETWEEN V_DTINI AND V_DTFIM)
                              GROUP BY CDFILCENTPME, CDFILIAL, CDSERVFILI, DTCARDIAPME, NRCARDPME) CD
                        WHERE CD.CDFILIAL       =   SRV.CDFILIAL
                        AND CD.CDSERVFILI     =   SRV.CDSERVFILI
                        AND SRV.CDFILIAL       =   C_ETL.CDFILIAL
                        AND CD.DTCARDAPIO BETWEEN V_DTINI AND V_DTFIM
                        AND GS.CDGRUPSERV (+)  =   SRV.CDGRUPSERV
                        AND CP.CDFILICPLA      =   C_ETL.CDFILIAL
                        AND CP.CDSERVCPLA      =   SRV.CDSERVFILI
                        AND CP.DTCONSPLAN      =   CD.DTCARDAPIO
                        AND CP.NRCONSPLAN      =   V_CDSEQUENCIAL
                        GROUP BY CD.DTCARDAPIO, SRV.CDSERVFILI, SRV.CDFILIAL, GS.CDGRUPSERV)SE
                 GROUP BY SE.CDSERVFILI, SE.CDGRUPSERV )  LOOP

                  BEGIN
                     SELECT VRCUSTPADR
                     INTO V_VRCUSTPADR
                     FROM CUSTPADR
                     WHERE CDFILIAL     = C_ETL.CDFILIAL
                       AND CDSERVFILI   = C_SERVICO.CDSERVFILI
                       AND DTREFCUSPADR = (SELECT MAX(DTREFCUSPADR)
                                             FROM   CUSTPADR
                                             WHERE  CDFILIAL      = C_ETL.CDFILIAL
                                               AND  CDSERVFILI    = C_SERVICO.CDSERVFILI
                                               AND  DTREFCUSPADR <= V_DTFIM);
                     EXCEPTION
                        WHEN OTHERS THEN
                           V_VRCUSTPADR := V_ZERO;
                  END;

                  FOR C_PRODUTO IN
                     ( SELECT PR.CDFILIAL, PR.CDSERVFILI, GPS.CDGRUPSERV,
                         SUM(PR.CUSTOPLAN1)  CUSTOPLAN1,
                         SUM(PR.CUSTOPLAN2)  CUSTOPLAN2,
                         SUM(PR.CUSTOPLAN3)  CUSTOPLAN3,
                         SUM(PR.CUSTOREAL1)  CUSTOREAL1,
                         SUM(PR.CUSTOREAL2)  CUSTOREAL2,
                         SUM(PR.CUSTOREAL3)  CUSTOREAL3,
                         SUM(PR.CUSTOPLANCENT1)  CUSTOPLANCENT1,
                         SUM(PR.CUSTOPLANCENT2)  CUSTOPLANCENT2,
                         SUM(PR.CUSTOPLANCENT3)  CUSTOPLANCENT3,
                         SUM(PR.CUSTOREALCENT1)  CUSTOREALCENT1,
                         SUM(PR.CUSTOREALCENT2)  CUSTOREALCENT2,
                         SUM(PR.CUSTOREALCENT3)  CUSTOREALCENT3,
                         PR.CDPRODUTO
                     FROM  GRUPSERV GPS, SERVICO SVC,
                         ( SELECT
                              CP.CDFILICPLA CDFILIAL,
                              CP.CDSERVCPLA CDSERVFILI,
                              (DECODE(V_NRTIPOCUSTO1,
                                     NULL, NULL,
                                     (CUSTO_PRODUTO(CP.CDFILICPLA, CP.CDPRODCPLA, V_NRTIPOCUSTO1, DECODE(PG.IDUTCARDPADR, 'S', CD.DTREFECUSTMES, CP.DTCONSPLAN), SYSDATE) * CP.QTCONSPLAN))) AS CUSTOPLAN1,
                              (DECODE(V_NRTIPOCUSTO2,
                                     NULL, NULL,
                                     (CUSTO_PRODUTO(CP.CDFILICPLA, CP.CDPRODCPLA, V_NRTIPOCUSTO2, DECODE(PG.IDUTCARDPADR, 'S', CD.DTREFECUSTMES, CP.DTCONSPLAN), SYSDATE) * CP.QTCONSPLAN))) AS CUSTOPLAN2,
                              (DECODE(V_NRTIPOCUSTO3,
                                     NULL, NULL,
                                     (CUSTO_PRODUTO(CP.CDFILICPLA, CP.CDPRODCPLA, V_NRTIPOCUSTO3, DECODE(PG.IDUTCARDPADR, 'S', CD.DTREFECUSTMES, CP.DTCONSPLAN), SYSDATE) * CP.QTCONSPLAN))) AS CUSTOPLAN3,
                              (DECODE(V_NRTIPOCUSTO1, NULL, NULL, 0)) AS CUSTOREAL1,
                              (DECODE(V_NRTIPOCUSTO2, NULL, NULL, 0)) AS CUSTOREAL2,
                              (DECODE(V_NRTIPOCUSTO3, NULL, NULL, 0)) AS CUSTOREAL3,

                              (DECODE(V_NRTIPOCUSTO1,
                                     NULL, NULL,
                                     (CUSTO_PRODUTO(C_ETL.CDFILCENTPME, CP.CDPRODCPLA, V_NRTIPOCUSTO1, DECODE(PG.IDUTCARDPADR, 'S', CD.DTREFECUSTMES, CP.DTCONSPLAN), SYSDATE) * CP.QTCONSPLAN))) AS CUSTOPLANCENT1,
                              (DECODE(V_NRTIPOCUSTO2,
                                     NULL, NULL,
                                     (CUSTO_PRODUTO(C_ETL.CDFILCENTPME, CP.CDPRODCPLA, V_NRTIPOCUSTO2, DECODE(PG.IDUTCARDPADR, 'S', CD.DTREFECUSTMES, CP.DTCONSPLAN), SYSDATE) * CP.QTCONSPLAN))) AS CUSTOPLANCENT2,
                              (DECODE(V_NRTIPOCUSTO3,
                                     NULL, NULL,
                                     (CUSTO_PRODUTO(C_ETL.CDFILCENTPME, CP.CDPRODCPLA, V_NRTIPOCUSTO3, DECODE(PG.IDUTCARDPADR, 'S', CD.DTREFECUSTMES, CP.DTCONSPLAN), SYSDATE) * CP.QTCONSPLAN))) AS CUSTOPLANCENT3,
                              (DECODE(V_NRTIPOCUSTO1, NULL, NULL, 0)) AS CUSTOREALCENT1,
                              (DECODE(V_NRTIPOCUSTO2, NULL, NULL, 0)) AS CUSTOREALCENT2,
                              (DECODE(V_NRTIPOCUSTO3, NULL, NULL, 0)) AS CUSTOREALCENT3,

                              CP.CDPRODCPLA CDPRODUTO
                          FROM
                              CONSPLAN CP, PARAMGERAL PG,
                              (SELECT  CD.CDFILIAL, CD.CDSERVFILI, CD.DTMESCARD, MAX(CM.DTREFECUSTMES) DTREFECUSTMES
                               FROM    CARDADIA CD, CARDAMES CM
                               WHERE   CD.CDFILIAL       =    C_ETL.CDFILIAL       AND
                                       CD.CDSERVFILI     =    C_SERVICO.CDSERVFILI AND
                                       CD.DTCARDAPIO BETWEEN V_DTINI AND V_DTFIM   AND
                                       (CD.CDFILIAL   = CM.CDFILIAL     ) AND
                                       (CD.CDSERVFILI = CM.CDSERVFILI   ) AND
                                       (CD.DTMESCARD  = CM.DTMESCARDAPIO)
                               GROUP BY CD.CDFILIAL, CD.CDSERVFILI, CD.DTMESCARD) CD
                          WHERE
                              CP.CDFILICPLA   =  C_ETL.CDFILIAL              AND
                              CP.NRCONSPLAN   =  V_CDSEQUENCIAL              AND
                              CD.CDFILIAL     =  CP.CDFILICPLA               AND
                              CD.CDSERVFILI   =  CP.CDSERVCPLA               AND
                              PG.CDPARGERAL   = '0001'                       AND
                              CD.DTMESCARD    = ADD_MONTHS(LAST_DAY(CP.DTCONSPLAN) + 1, -1)

                          UNION ALL

                          SELECT
                              H.CDFILIAL,
                              H.CDSERVFILI,
                              (DECODE(V_NRTIPOCUSTO1,
                                      NULL, NULL,
                                      ROUND(CNE.VRPLANNESTO * (RNE.PERATENESTO/100) * (CD.QTCOMESTICAR/H.TOTCOMEN), 5))) AS CUSTOPLAN1,
                              (DECODE(V_NRTIPOCUSTO2,
                                      NULL, NULL,
                                      ROUND(CNE.VRPLANNESTO * (RNE.PERATENESTO/100) * (CD.QTCOMESTICAR/H.TOTCOMEN), 5))) AS CUSTOPLAN2,
                              (DECODE(V_NRTIPOCUSTO3,
                                      NULL, NULL,
                                      ROUND(CNE.VRPLANNESTO * (RNE.PERATENESTO/100) * (CD.QTCOMESTICAR/H.TOTCOMEN), 5))) AS CUSTOPLAN3,
                              (DECODE (V_NRTIPOCUSTO1, NULL, NULL, 0)) AS CUSTOREAL1,
                              (DECODE (V_NRTIPOCUSTO2, NULL, NULL, 0)) AS CUSTOREAL2,
                              (DECODE (V_NRTIPOCUSTO3, NULL, NULL, 0)) AS CUSTOREAL3,
                                                        /*CLCULO DA CENTRAL*/
                              (DECODE(V_NRTIPOCUSTO1,
                                      NULL, NULL,
                                      ROUND(CNE.VRPLANNESTO * (RNE.PERATENESTO/100) * (CD.QTCOMESTICAR/H.TOTCOMEN), 5))) AS CUSTOPLANCENT1,
                              (DECODE(V_NRTIPOCUSTO2,
                                      NULL, NULL,
                                      ROUND(CNE.VRPLANNESTO * (RNE.PERATENESTO/100) * (CD.QTCOMESTICAR/H.TOTCOMEN), 5))) AS CUSTOPLANCENT2,
                              (DECODE(V_NRTIPOCUSTO3,
                                      NULL, NULL,
                                      ROUND(CNE.VRPLANNESTO * (RNE.PERATENESTO/100) * (CD.QTCOMESTICAR/H.TOTCOMEN), 5))) AS CUSTOPLANCENT3,
                              (DECODE (V_NRTIPOCUSTO1, NULL, NULL, 0)) AS CUSTOREALCENT1,
                              (DECODE (V_NRTIPOCUSTO2, NULL, NULL, 0)) AS CUSTOREALCENT2,
                              (DECODE (V_NRTIPOCUSTO3, NULL, NULL, 0)) AS CUSTOREALCENT3,

                              CNE.CDPRODUTO AS CDPRODUTO
                          FROM
                              (
                              SELECT
                                  CDR.CDFILIAL,   CDR.CDSERVFILI,  CDR.DTMESCARD,
                                  SUM(QTCOMESTICAR) AS TOTCOMEN
                               FROM
                                  CARDADIA CDR
                               WHERE
                                  (CDR.CDFILIAL         =   C_ETL.CDFILIAL       ) AND
                                  (CDR.CDSERVFILI       =   C_SERVICO.CDSERVFILI ) AND
                                  (CDR.DTCARDAPIO BETWEEN   V_DTINI AND V_DTFIM )
                               GROUP BY
                                  CDSERVFILI,
                                  CDR.CDFILIAL,
                                  CDR.CDSERVFILI,
                                  CDR.DTMESCARD
                              ) H,
                              RATENESTO RNE,
                              CUSTNESTO CNE,
                              CARDADIA  CD
                          WHERE
                              (CD.CDFILIAL      =    C_ETL.CDFILIAL         )   AND
                              (H.CDFILIAL       =    C_ETL.CDFILIAL         )   AND
                              (CNE.CDFILIAL     =    C_ETL.CDFILIAL         )   AND
                              (RNE.CDFILIAL     =    C_ETL.CDFILIAL         )   AND
                              (CD.CDSERVFILI    =    C_SERVICO.CDSERVFILI   )   AND
                              (H.CDSERVFILI     =    C_SERVICO.CDSERVFILI   )   AND
                              (RNE.CDSERVFILI   =    C_SERVICO.CDSERVFILI   )   AND
                              (CNE.CDPRODUTO    =    RNE.CDPRODUTO           )   AND
                              (CD.DTMESCARD     =    H.DTMESCARD             )   AND
                              (CD.DTCARDAPIO BETWEEN   V_DTINI AND V_DTFIM )   AND
                              (NOT H.TOTCOMEN IS NULL AND H.TOTCOMEN <> 0    )

                          UNION ALL

------------------------------------------------/* CUSTO PLANEJADO MERENDA */
                           SELECT
                              CP.CDFILICPLA CDFILIAL,
                              CP.CDSERVCPLA CDSERVFILI,
                              (DECODE(V_NRTIPOCUSTO1,
                                     NULL, NULL,
                                     (CUSTO_PRODUTO(CP.CDFILICPLA, CP.CDPRODCPLA, V_NRTIPOCUSTO1, DECODE(PG.IDUTCARDPADR, 'S', CD.DTREFECUSTMES, CP.DTCONSPLAN), SYSDATE) * CP.QTCONSPLAN))) AS CUSTOPLAN1,
                              (DECODE(V_NRTIPOCUSTO2,
                                     NULL, NULL,
                                     (CUSTO_PRODUTO(CP.CDFILICPLA, CP.CDPRODCPLA, V_NRTIPOCUSTO2, DECODE(PG.IDUTCARDPADR, 'S', CD.DTREFECUSTMES, CP.DTCONSPLAN), SYSDATE) * CP.QTCONSPLAN))) AS CUSTOPLAN2,
                              (DECODE(V_NRTIPOCUSTO3,
                                     NULL, NULL,
                                     (CUSTO_PRODUTO(CP.CDFILICPLA, CP.CDPRODCPLA, V_NRTIPOCUSTO3, DECODE(PG.IDUTCARDPADR, 'S', CD.DTREFECUSTMES, CP.DTCONSPLAN), SYSDATE) * CP.QTCONSPLAN))) AS CUSTOPLAN3,
                              (DECODE(V_NRTIPOCUSTO1, NULL, NULL, 0)) AS CUSTOREAL1,
                              (DECODE(V_NRTIPOCUSTO2, NULL, NULL, 0)) AS CUSTOREAL2,
                              (DECODE(V_NRTIPOCUSTO3, NULL, NULL, 0)) AS CUSTOREAL3,

                                                        /*CLCULO DA CENTRAL*/
                              (DECODE(V_NRTIPOCUSTO1,
                                     NULL, NULL,
                                     (CUSTO_PRODUTO(C_ETL.CDFILCENTPME, CP.CDPRODCPLA, V_NRTIPOCUSTO1, DECODE(PG.IDUTCARDPADR, 'S', CD.DTREFECUSTMES, CP.DTCONSPLAN), SYSDATE) * CP.QTCONSPLAN))) AS CUSTOPLANCENT1,
                              (DECODE(V_NRTIPOCUSTO2,
                                     NULL, NULL,
                                     (CUSTO_PRODUTO(C_ETL.CDFILCENTPME, CP.CDPRODCPLA, V_NRTIPOCUSTO2, DECODE(PG.IDUTCARDPADR, 'S', CD.DTREFECUSTMES, CP.DTCONSPLAN), SYSDATE) * CP.QTCONSPLAN))) AS CUSTOPLANCENT2,
                              (DECODE(V_NRTIPOCUSTO3,
                                     NULL, NULL,
                                     (CUSTO_PRODUTO(C_ETL.CDFILCENTPME, CP.CDPRODCPLA, V_NRTIPOCUSTO3, DECODE(PG.IDUTCARDPADR, 'S', CD.DTREFECUSTMES, CP.DTCONSPLAN), SYSDATE) * CP.QTCONSPLAN))) AS CUSTOPLANCENT3,
                              (DECODE(V_NRTIPOCUSTO1, NULL, NULL, 0)) AS CUSTOREALCENT1,
                              (DECODE(V_NRTIPOCUSTO2, NULL, NULL, 0)) AS CUSTOREALCENT2,
                              (DECODE(V_NRTIPOCUSTO3, NULL, NULL, 0)) AS CUSTOREALCENT3,

                              CP.CDPRODCPLA CDPRODUTO
                          FROM
                              CONSPLAN CP, PARAMGERAL PG,  CARDIAPME CDI,
                              (
                                 SELECT  CDFILIAL, CDSERVFILI, MAX(DTCARDIAPME) AS DTREFECUSTMES
                                 FROM    CARDIAPME
                                 WHERE   CDFILIAL       =    C_ETL.CDFILIAL       AND
                                        CDSERVFILI     =    C_SERVICO.CDSERVFILI AND
                                       DTCARDIAPME BETWEEN V_DTINI AND V_DTFIM
                                GROUP BY CDFILIAL, CDSERVFILI
                              ) CD
                          WHERE
                              CP.CDFILICPLA    =  C_ETL.CDFILIAL              AND
                              CP.NRCONSPLAN    =  V_CDSEQUENCIAL              AND
                              CD.CDFILIAL      =  CP.CDFILICPLA               AND
                              CD.CDSERVFILI    =  CP.CDSERVCPLA               AND
                              PG.CDPARGERAL    = '0001'                       AND
                              CDI.CDSERVFILI   =  CP.CDSERVCPLA               AND
                              CDI.CDFILIAL     =  C_ETL.CDFILIAL              AND
                              CDI.CDSERVFILI   =  C_SERVICO.CDSERVFILI        AND
                              CDI.CDFILCENTPME =  CP.CDFILCENTPME             AND
                              CDI.DTCARDIAPME   =  CP.DTCONSPLAN               AND
                              CDI.DTCARDIAPME  BETWEEN V_DTINI AND V_DTFIM


                          UNION ALL

                          SELECT
                              C.CDFILIAL,
                              C.CDSERVFILI,
                              (DECODE(V_NRTIPOCUSTO1, NULL, NULL, 0)) CUSTOPLAN1,
                              (DECODE(V_NRTIPOCUSTO2, NULL, NULL, 0)) CUSTOPLAN2,
                              (DECODE(V_NRTIPOCUSTO3, NULL, NULL, 0)) CUSTOPLAN3,
                              (DECODE(V_NRTIPOCUSTO1,
                                       NULL, NULL,
                                       (C.QTRETIRADA * CUSTO_PRODUTO(C.CDFILIAL, C.CDPRODUTO, V_NRTIPOCUSTO1, C.DTCARDAPIO, SYSDATE)))) AS CUSTOREAL1,
                              (DECODE(V_NRTIPOCUSTO2,
                                       NULL, NULL,
                                       (C.QTRETIRADA * CUSTO_PRODUTO(C.CDFILIAL, C.CDPRODUTO, V_NRTIPOCUSTO2, C.DTCARDAPIO, SYSDATE)))) AS CUSTOREAL2,
                              (DECODE(V_NRTIPOCUSTO3,
                                       NULL, NULL,
                                       (C.QTRETIRADA * CUSTO_PRODUTO(C.CDFILIAL, C.CDPRODUTO, V_NRTIPOCUSTO3, C.DTCARDAPIO, SYSDATE)))) AS CUSTOREAL3,

                                       /*CLCULO DA CENTRAL*/

                              (DECODE(V_NRTIPOCUSTO1, NULL, NULL, 0)) CUSTOPLANCENT1,
                              (DECODE(V_NRTIPOCUSTO2, NULL, NULL, 0)) CUSTOPLANCENT2,
                              (DECODE(V_NRTIPOCUSTO3, NULL, NULL, 0)) CUSTOPLANCENT3,
                              (DECODE(V_NRTIPOCUSTO1,
                                       NULL, NULL,
                                       (C.QTRETIRADA * CUSTO_PRODUTO(C_ETL.CDFILCENTPME, C.CDPRODUTO, V_NRTIPOCUSTO1, C.DTCARDAPIO, SYSDATE)))) AS CUSTOREALCENT1,
                              (DECODE(V_NRTIPOCUSTO2,
                                       NULL, NULL,
                                       (C.QTRETIRADA * CUSTO_PRODUTO(C_ETL.CDFILCENTPME, C.CDPRODUTO, V_NRTIPOCUSTO2, C.DTCARDAPIO, SYSDATE)))) AS CUSTOREALCENT2,
                              (DECODE(V_NRTIPOCUSTO3,
                                       NULL, NULL,
                                       (C.QTRETIRADA * CUSTO_PRODUTO(C_ETL.CDFILCENTPME, C.CDPRODUTO, V_NRTIPOCUSTO3, C.DTCARDAPIO, SYSDATE)))) AS CUSTOREALCENT3,

                              C.CDPRODUTO
                          FROM
                              (
                              SELECT
                                 CA.CDFILIAL,
                                 CA.CDSERVFILI,
                                 CA.DTCARDAPIO,
                                 SUM(IR.QTRETIRADA * PR.VRFATOCONV) AS QTRETIRADA,
                                 PR.CDPRODUTO
                              FROM
                                 CARDADIA CA,
                                 PRODUTO  PR,
                                 ITEMRETI IR
                              WHERE
                                 (IR.CDFILIAL       =     C_ETL.CDFILIAL       )   AND
                                 (CA.CDFILIAL       =     C_ETL.CDFILIAL       )   AND
                                 (CA.CDSERVFILI     =     C_SERVICO.CDSERVFILI )   AND
                                 (PR.CDPRODUTO      =     PR.CDPRODESTO         )   AND
                                 (PR.CDPRODUTO      =     IR.CDPRODUTO          )   AND
                                 (CA.CDFILIAL       =     IR.CDFILIAL           )   AND
                                 (IR.NRCARDAPIO     =     CA.NRCARDAPIO         )   AND
                                 (CA.DTCARDAPIO BETWEEN V_DTINI AND V_DTFIM   )
                              GROUP BY
                                 CA.CDFILIAL,
                                 CA.CDSERVFILI,
                                 CA.DTCARDAPIO,
                                 PR.CDPRODUTO
                              ) C

                          UNION ALL

                          SELECT
                              CA.CDFILIAL,
                              CA.CDSERVFILI,
                              (DECODE(V_NRTIPOCUSTO1, NULL, NULL, 0)) CUSTOPLAN1,
                              (DECODE(V_NRTIPOCUSTO2, NULL, NULL, 0)) CUSTOPLAN2,
                              (DECODE(V_NRTIPOCUSTO3, NULL, NULL, 0)) CUSTOPLAN3,
                              (DECODE(V_NRTIPOCUSTO1,
                                      NULL, NULL,
                                      ROUND(CNE.VRREALNESTO * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5))) AS CUSTOREAL1,
                              (DECODE(V_NRTIPOCUSTO2,
                                      NULL, NULL,
                                      ROUND(CNE.VRREALNESTO * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5))) AS CUSTOREAL2,
                              (DECODE(V_NRTIPOCUSTO3,
                                      NULL, NULL,
                                      ROUND(CNE.VRREALNESTO * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5))) AS CUSTOREAL3,

                                      /*CLCULO DA CENTRAL*/

                              (DECODE(V_NRTIPOCUSTO1, NULL, NULL, 0)) CUSTOPLANCENT1,
                              (DECODE(V_NRTIPOCUSTO2, NULL, NULL, 0)) CUSTOPLANCENT2,
                              (DECODE(V_NRTIPOCUSTO3, NULL, NULL, 0)) CUSTOPLANCENT3,
                              (DECODE(V_NRTIPOCUSTO1,
                                      NULL, NULL,
                                      ROUND(CNE.VRREALNESTO * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5))) AS CUSTOREALCENT1,
                              (DECODE(V_NRTIPOCUSTO2,
                                      NULL, NULL,
                                      ROUND(CNE.VRREALNESTO * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5))) AS CUSTOREALCENT2,
                              (DECODE(V_NRTIPOCUSTO3,
                                      NULL, NULL,
                                      ROUND(CNE.VRREALNESTO * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5))) AS CUSTOREALCENT3,

                              CNE.CDPRODUTO
                          FROM
                              (
                              SELECT
                                  DTMESCARD,
                                  CDSERVFILI,
                                  SUM(QTCOMEFETCAR) AS TOTCOMEN
                               FROM
                                  CARDADIA CDR
                               WHERE
                                  (CDR.CDFILIAL      = C_ETL.CDFILIAL        )     AND
                                  (CDR.CDSERVFILI    = C_SERVICO.CDSERVFILI  )     AND
                                  (DTCARDAPIO BETWEEN  V_DTINI AND V_DTFIM  )
                               GROUP BY
                                  DTMESCARD,
                                  CDSERVFILI
                               ) TC,
                              CARDADIA  CA,
                              RATENESTO RNE,
                              CUSTNESTO CNE
                          WHERE
                              (CA.DTCARDAPIO BETWEEN  V_DTINI AND V_DTFIM  )  AND
                              (CA.CDFILIAL         =  C_ETL.CDFILIAL        )  AND
                              (RNE.CDFILIAL        =  C_ETL.CDFILIAL        )  AND
                              (CNE.CDFILIAL        =  C_ETL.CDFILIAL        )  AND
                              (RNE.CDSERVFILI      =  C_SERVICO.CDSERVFILI  )  AND
                              (CA.CDSERVFILI       =  C_SERVICO.CDSERVFILI  )  AND
                              (CA.CDSERVFILI       =  RNE.CDSERVFILI         )  AND
                              (RNE.CDPRODUTO       =  CNE.CDPRODUTO          )  AND
                              (TC.DTMESCARD        =  CA.DTMESCARD           )  AND
                              (NOT TC.TOTCOMEN IS NULL AND TC.TOTCOMEN <> 0  )  AND
                              (NOT CNE.VRREALNESTO IS NULL                   )  AND
                              (TO_CHAR(CA.DTCARDAPIO, 'MMYYYY') = TO_CHAR(CNE.DTCUSTNESTO, 'MMYYYY'))

                          UNION ALL

                          SELECT
                              RNE.CDFILIAL,
                              RNE.CDSERVFILI,
                              (DECODE(V_NRTIPOCUSTO1, NULL, NULL, 0)) CUSTOPLAN1,
                              (DECODE(V_NRTIPOCUSTO2, NULL, NULL, 0)) CUSTOPLAN2,
                              (DECODE(V_NRTIPOCUSTO3, NULL, NULL, 0)) CUSTOPLAN3,
                              (DECODE(V_NRTIPOCUSTO1,
                                       NULL, NULL,
                                       ROUND(TCN.VRTOTAITEM * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5))) AS CUSTOREAL1,
                              (DECODE(V_NRTIPOCUSTO2,
                                       NULL, NULL,
                                       ROUND(TCN.VRTOTAITEM * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5))) AS CUSTOREAL2,
                              (DECODE(V_NRTIPOCUSTO3,
                                       NULL, NULL,
                                       ROUND(TCN.VRTOTAITEM * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5))) AS CUSTOREAL3,

                                       /*CLCULO DA CENTRAL*/

                              (DECODE(V_NRTIPOCUSTO1, NULL, NULL, 0)) CUSTOPLANCENT1,
                              (DECODE(V_NRTIPOCUSTO2, NULL, NULL, 0)) CUSTOPLANCENT2,
                              (DECODE(V_NRTIPOCUSTO3, NULL, NULL, 0)) CUSTOPLANCENT3,
                              (DECODE(V_NRTIPOCUSTO1,
                                       NULL, NULL,
                                       ROUND(TCN.VRTOTAITEM * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5))) AS CUSTOREALCENT1,
                              (DECODE(V_NRTIPOCUSTO2,
                                       NULL, NULL,
                                       ROUND(TCN.VRTOTAITEM * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5))) AS CUSTOREALCENT2,
                              (DECODE(V_NRTIPOCUSTO3,
                                       NULL, NULL,
                                       ROUND(TCN.VRTOTAITEM * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5))) AS CUSTOREALCENT3,
                              TCN.CDPRODUTO
                          FROM
                              RATENESTO   RNE,
                              CARDADIA    CA,
                              (
                              SELECT
                                  DTMESCARD,         CDSERVFILI,
                                  SUM(QTCOMEFETCAR) AS TOTCOMEN
                               FROM
                                  CARDADIA CDR
                               WHERE
                                  (CDR.CDFILIAL     = C_ETL.CDFILIAL       ) AND
                                  (CDR.CDSERVFILI   = C_SERVICO.CDSERVFILI ) AND
                                  (DTCARDAPIO BETWEEN V_DTINI AND V_DTFIM )
                               GROUP BY
                                  DTMESCARD,
                                  CDSERVFILI
                               ) TC,
                               (
                               SELECT
                                   TO_CHAR(NF.DTENTRSAID, 'MMYYYY') AS DTMESNF,
                                   IP.CDPRODUTO,
                                   SUM(IP.VRTOTAITEM) AS VRTOTAITEM
                                FROM
                                   NOTAFISCAL  NF,
                                   ITEMPRODUTO IP
                                WHERE
                                  (NF.IDENTRSAIDOP     =     'E'                   )  AND
                                  (IP.CDFILIAL         =     NF.CDFILIAL           )  AND
                                  (IP.NRLANCTONF       =     NF.NRLANCTONF         )  AND
                                  (NF.CDFILIAL         =     C_ETL.CDFILIAL       )  AND
                                  (IP.CDFILIAL         =     C_ETL.CDFILIAL       )  AND
                                  (NF.DTENTRSAID BETWEEN V_DTINI AND V_DTFIM     )
                                GROUP BY
                                   TO_CHAR(NF.DTENTRSAID, 'MMYYYY'),
                                   IP.CDPRODUTO
                              ) TCN
                          WHERE
                              (CA.CDFILIAL         =      C_ETL.CDFILIAL       ) AND
                              (RNE.CDFILIAL        =      C_ETL.CDFILIAL       ) AND
                              (CA.CDFILIAL         =      RNE.CDFILIAL          ) AND
                              (CA.CDSERVFILI       =      C_SERVICO.CDSERVFILI ) AND
                              (RNE.CDSERVFILI      =      C_SERVICO.CDSERVFILI ) AND
                              (TCN.CDPRODUTO       =      RNE.CDPRODUTO         ) AND
                              (TC.DTMESCARD        =      CA.DTMESCARD          ) AND
                              (TC.CDSERVFILI       =      CA.CDSERVFILI         ) AND
                              (NOT TC.TOTCOMEN IS NULL AND TC.TOTCOMEN <> 0     ) AND
                              (CA.DTCARDAPIO BETWEEN V_DTINI AND V_DTFIM      ) AND
                              (TO_CHAR(CA.DTCARDAPIO, 'MMYYYY') = TCN.DTMESNF   ) AND
                              (NOT EXISTS (
                                           SELECT
                                                  CDFILIAL
                                           FROM
                                                  CUSTNESTO
                                           WHERE
                                                  CDFILIAL         =     C_ETL.CDFILIAL  AND
                                                  DTCUSTNESTO      =     CA.DTCARDAPIO    AND
                                                  CDPRODUTO        =     RNE.CDPRODUTO    AND
                                                  NOT VRREALNESTO IS NULL
                                           ))

                         ) PR
                         WHERE
                              (SVC.CDFILIAL       =       C_ETL.CDFILIAL      )  AND
                              (SVC.CDSERVFILI     =       C_SERVICO.CDSERVFILI)  AND
                              (SVC.CDGRUPSERV     =      GPS.CDGRUPSERV (+)   )  AND
                              (SVC.CDFILIAL       =      PR.CDFILIAL          )  AND
                              (SVC.CDSERVFILI     =      PR.CDSERVFILI        )
                         GROUP BY
                              PR.CDFILIAL,
                              PR.CDSERVFILI,
                              GPS.CDGRUPSERV,
                              PR.CDPRODUTO
                  ) LOOP

                        INSERT INTO ETL_RESUFOOD
                        (
                        CDFILIAL,              CDAREAGERE,             CDSUPERVISOR,
                        CDGOPERAC,             CDEMPRESA,              CDSEGMER,
                        CDPRODUTO,             CDANOBI,                CDMESBI,
                        BIETLFOOD,             TRETLFOOD,              SEETLFOOD,
                        VRCUSPLAETLFOO1,       VRCUSPLAETLFOO2,        VRCUSPLAETLFOO3,
                        VRCUSREAETLFOO1,       VRCUSREAETLFOO2,        VRCUSREAETLFOO3,
                        CDGRUPSERV,            CDFILISERVFILI,         VRCUSPLACENTFO1,
                        VRCUSPLACENTFO2,       VRCUSPLACENTFO3,        VRCUSREACENTFO1,
                        VRCUSREACENTFO2,       VRCUSREACENTFO3,        CDETLFILCENTPME
                        )
                     VALUES
                        (
                        C_ETL.CDFILIAL,        C_ETL.CDAREAGERE,       C_ETL.CDSUPERVISOR,
                        C_ETL.CDGOPERAC,       C_ETL.CDEMPRESA,        C_ETL.CDSEGMER,
                        C_PRODUTO.CDPRODUTO,   V_ANO,                  V_MES,
                        V_BIM,                 V_TRI,                  V_SEM,
                        C_PRODUTO.CUSTOPLAN1,  C_PRODUTO.CUSTOPLAN2,   C_PRODUTO.CUSTOPLAN3,
                        C_PRODUTO.CUSTOREAL1,  C_PRODUTO.CUSTOREAL2,   C_PRODUTO.CUSTOREAL3,
                        C_PRODUTO.CDGRUPSERV,  C_ETL.CDFILIAL||C_SERVICO.CDSERVFILI,
                        C_PRODUTO.CUSTOPLANCENT1, C_PRODUTO.CUSTOPLANCENT2,  C_PRODUTO.CUSTOPLANCENT3,
                        C_PRODUTO.CUSTOREALCENT1, C_PRODUTO.CUSTOREALCENT2,  C_PRODUTO.CUSTOREALCENT3,
                        C_ETL.CDFILCENTPME
                        );

                       V_COUNTER := V_COUNTER+1;
                       IF V_COUNTER >= 500 THEN
                           COMMIT;
                           V_COUNTER := 0;
                        END IF;  
                  END LOOP;


                  INSERT INTO ETL_RESUSERV
                    (CDFILIAL,                  CDAREAGERE,
                     CDSUPERVISOR,              CDGOPERAC,
                     CDEMPRESA,                 CDSEGMER,
                     CDGRUPSERV,                CDFILISERVFILI,
                     CDANOBI,                   CDMESBI,
                     BIETLSERV,                 TRETLSERV,
                     SEETLSERV,                 QTCOMESTETLSERV,
                     QTCOMEFEETLSERV,           VRCUSPADETLSERV )
                  VALUES
                     (C_ETL.CDFILIAL,            C_ETL.CDAREAGERE,
                      C_ETL.CDSUPERVISOR,        C_ETL.CDGOPERAC,
                      C_ETL.CDEMPRESA,           C_ETL.CDSEGMER,
                      C_SERVICO.CDGRUPSERV,      C_ETL.CDFILIAL||C_SERVICO.CDSERVFILI,
                      V_ANO,                     V_MES,
                      V_BIM,                     V_TRI,
                      V_SEM,                     C_SERVICO.QTCOMESTICAR,
                      C_SERVICO.QTCOMEFETCAR,    V_VRCUSTPADR);

               V_COUNTER := V_COUNTER+1;

               IF V_COUNTER >= 500 THEN
                  COMMIT;
                  V_COUNTER := 0;
               END IF;
            END LOOP;

            DELETE FROM CONSPLAN
            WHERE NRCONSPLAN = V_CDSEQUENCIAL;

         END IF;
      END LOOP;
      COMMIT;
      V_DTINI := ADD_MONTHS(V_DTINI,1);
   END LOOP;

-------------------------------------------------------/* ELSE CUSTO DIMENSAO*/

  ELSE
      FOR C_NRTPCUS IN
         (SELECT CDTIPOCUSTO, TO_NUMBER(CDTIPOCUSTO) NRTIPOCUSTO
          FROM   TIPOCUSTO
          WHERE IDTPCUSTOGSC = 'S'
          ORDER BY NRTIPOCUSTO
          )LOOP

         V_DTINI := ADD_MONTHS(LAST_DAY(P_DTINI) + 1, -1);

         WHILE (V_DTINI  <=  P_DTFINA) LOOP
            V_DTFIM      :=   LAST_DAY( V_DTINI);
            V_MES        :=   TO_CHAR(V_DTFIM,'MM');
            V_ANO        :=   TO_CHAR(V_DTFIM,'YYYY');
            V_BIM        :=   TO_CHAR(TRUNC((V_MES - 1) / 2) + 1)||' Bim';
            V_TRI        :=   TO_CHAR(TRUNC((V_MES - 1) / 3) + 1)||' Tri';
            V_SEM        :=   TO_CHAR(TRUNC((V_MES - 1) / 6) + 1)||' Sem';

            FOR C_ETL IN
               (SELECT FL.CDFILIAL,        FL.CDAREAGERE,          FL.DTINICIALBI,
                       FL.CDSUPERVISOR,    FL.CDGOPERAC,           FL.CDEMPRESA,
                       FL.CDSEGMER , FL.CDFILCENTPME
                  FROM FILIAL FL, PARAMFILIAL P
                 WHERE P.CDFILIAL = FL.CDFILIAL
                   AND FL.IDFUNCAOFILI IS NULL
                   AND FL.DTINICIALBI  IS NOT NULL
                  and nvl(IDCTRLESTQ, w_S) <> w_N
                  AND NVL(IDCNTRRESC, w_N) <> w_S
                  AND CDFILCENTPME    = '9999'
                  ORDER BY FL.CDFILIAL) LOOP

         IF ADD_MONTHS(LAST_DAY(C_ETL.DTINICIALBI) + 1, -1) <= V_DTINI THEN

             NOVO_CODIGO('CONSPLAN'||C_ETL.CDFILIAL, V_CDSEQUENCIAL,1);
                  V_CDSEQUENCIAL := SUBSTR(V_CDSEQUENCIAL,11,10);


                  CONSUMO_PLANEJADO_PLA(
                                        C_ETL.CDFILIAL,
                                        'T',
                                        V_DTINI,
                                        V_DTFIM,
                                        'T',
                                        'CFP',
                                        'N',
                                         0,
                                        'N',
                                         V_CDSEQUENCIAL,
                                        '0',
                                        'zzzzzzzzzz',
                                        '',
                                        '_'||TO_CHAR(V_DTINI, 'YYYYMMDD')||'_',
                                        '_'||TO_CHAR(V_DTFIM, 'YYYYMMDD')||'_'
                                        );
                  FOR C_SERVICO IN
                     (SELECT
                            SE.CDSERVFILI,                 SE.CDGRUPSERV,
                            SUM(SE.QTCOMESTICAR / TOTAL) AS QTCOMESTICAR,
                            SUM(SE.QTCOMEFETCAR / TOTAL) AS QTCOMEFETCAR
                      FROM(SELECT
                                  CP.DTCONSPLAN DTCARDAPIO,
                                  SRV.CDSERVFILI, GS.CDGRUPSERV,
                                  SUM(CAR.QTCOMESTICAR) QTCOMESTICAR,
                                  SUM(CAR.QTCOMEFETCAR) QTCOMEFETCAR,
                                  COUNT(*) AS TOTAL
                             FROM
                                  SERVICO SRV,   CARDADIA CAR,
                                  GRUPSERV GS,   CONSPLAN CP
                             WHERE
                                  CAR.CDFILIAL       =   SRV.CDFILIAL
                              AND CAR.CDSERVFILI     =   SRV.CDSERVFILI
                              AND SRV.CDFILIAL       =   C_ETL.CDFILIAL
                              AND CAR.DTCARDAPIO BETWEEN V_DTINI AND V_DTFIM
                              AND GS.CDGRUPSERV (+)  =   SRV.CDGRUPSERV
                              AND CP.CDFILICPLA      =   C_ETL.CDFILIAL
                              AND CP.CDSERVCPLA      =   SRV.CDSERVFILI
                              AND CP.DTCONSPLAN      =   CAR.DTCARDAPIO
                              AND CP.NRCONSPLAN      =   V_CDSEQUENCIAL

                            GROUP BY
                                  CP.DTCONSPLAN,
                                  SRV.CDSERVFILI,
                                  SRV.CDFILIAL,
                                  GS.CDGRUPSERV
                     UNION ALL

                             SELECT
                                  CAR.DTCARDAPIO,
                                  SRV.CDSERVFILI, GS.CDGRUPSERV,
                                  NVL(SUM(CAR.QTCOMESTICAR), 0) QTCOMESTICAR,
                                  NVL(SUM(CAR.QTCOMEFETCAR), 0) QTCOMEFETCAR,
                                  COUNT(*) AS TOTAL
                             FROM  SERVICO SRV,   CARDADIA CAR,
                                  GRUPSERV GS
                             WHERE
                                  CAR.CDFILIAL       =   SRV.CDFILIAL
                              AND CAR.CDSERVFILI     =   SRV.CDSERVFILI
                              AND SRV.CDFILIAL       =   C_ETL.CDFILIAL
                              AND CAR.DTCARDAPIO BETWEEN V_DTINI AND V_DTFIM
                              AND GS.CDGRUPSERV (+)  =   SRV.CDGRUPSERV
                              AND CAR.QTCOMESTICAR = 0
                              AND CAR.CDSERVFILI  NOT IN (
                                                         SELECT
                                                                CDSERVCPLA
                                                         FROM
                                                                CONSPLAN CP
                                                         WHERE
                                                                CP.DTCONSPLAN BETWEEN V_DTINI AND V_DTFIM
                                                           AND  CP.DTCONSPLAN = CAR.DTCARDAPIO
                                                           AND  CP.NRCONSPLAN = V_CDSEQUENCIAL
                                                           AND  CP.CDFILICPLA = C_ETL.CDFILIAL
                                                         )

                            GROUP BY
                                  CAR.DTCARDAPIO,
                                  SRV.CDSERVFILI,
                                  SRV.CDFILIAL,
                                  GS.CDGRUPSERV

                           UNION ALL
         --_________________________________________________________________________________--
                                            /*QUANTIDADE PLANEJADA MERENDA*/
                            SELECT
                                   CD.DTCARDAPIO,
                                   SRV.CDSERVFILI, GS.CDGRUPSERV,
                                   SUM(CD.QTCOMESTICAR) QTCOMESTICAR,
                                   SUM(QTCLIESTICAR) QTCOMEFETCAR,
                                   COUNT(*) AS TOTAL
                              FROM
                                    SERVICO SRV,    GRUPSERV GS,
                                    CONSPLAN CP,
                                   (SELECT
                                      CDFILCENTPME,
                                      CDFILIAL,
                                      CDSERVFILI,
                                      DTCARDIAPME DTCARDAPIO,
                                      NRCARDPME,
                                      SUM(QTCOMESTCPME) QTCOMESTICAR,
                                      SUM(QTCLIESTCPME) QTCLIESTICAR
                                    FROM
                                      CARDIAPME
                                    WHERE
                                       CDFILCENTPME = C_ETL.CDFILIAL  AND
                                       CDFILIAL = C_ETL.CDFILIAL  AND
                                      (DTCARDIAPME BETWEEN V_DTINI AND V_DTFIM)
                                    GROUP BY
                                      CDFILCENTPME,
                                      CDFILIAL,
                                      CDSERVFILI,
                                      DTCARDIAPME,
                                      NRCARDPME) CD
                              WHERE
                                  CD.CDFILIAL       =   SRV.CDFILIAL
                              AND CD.CDSERVFILI     =   SRV.CDSERVFILI
                              AND SRV.CDFILIAL       =   C_ETL.CDFILIAL
                              AND CD.DTCARDAPIO BETWEEN V_DTINI AND V_DTFIM
                              AND GS.CDGRUPSERV (+)  =   SRV.CDGRUPSERV
                              AND CP.CDFILICPLA      =   C_ETL.CDFILIAL
                              AND CP.CDSERVCPLA      =   SRV.CDSERVFILI
                              AND CP.DTCONSPLAN      =   CD.DTCARDAPIO
                              AND CP.NRCONSPLAN      =   V_CDSEQUENCIAL
                              GROUP BY CD.DTCARDAPIO, SRV.CDSERVFILI, SRV.CDFILIAL, GS.CDGRUPSERV )SE
                       GROUP BY SE.CDSERVFILI, SE.CDGRUPSERV  )  LOOP

                       BEGIN
                           SELECT  VRCUSTPADR
                           INTO V_VRCUSTPADR
                           FROM  CUSTPADR
                           WHERE CDFILIAL     = C_ETL.CDFILIAL
                               AND CDSERVFILI   = C_SERVICO.CDSERVFILI
                               AND DTREFCUSPADR = (SELECT MAX(DTREFCUSPADR)
                                                   FROM   CUSTPADR
                                                   WHERE  CDFILIAL      = C_ETL.CDFILIAL
                                                     AND  CDSERVFILI    = C_SERVICO.CDSERVFILI
                                                     AND  DTREFCUSPADR <= V_DTFIM);
                           EXCEPTION
                              WHEN OTHERS THEN
                                 V_VRCUSTPADR := V_ZERO;
                        END;

                        FOR C_PRODUTO IN
                           ( SELECT
                               PR.CDFILIAL, PR.CDSERVFILI, GPS.CDGRUPSERV,
                               SUM(CUSTOREAL) AS CUSTOREAL,
                               SUM(CUSTOPLAN) AS CUSTOPLAN,
                               SUM(CUSTOREALCENT) AS CUSTOREALCENT,
                               SUM(CUSTOPLANCENT) AS CUSTOPLANCENT,
                               PR.CDPRODUTO
                           FROM GRUPSERV GPS, SERVICO SVC,
                               (SELECT
                                    CP.CDFILICPLA CDFILIAL,
                                    CP.CDSERVCPLA CDSERVFILI,
                                    (CUSTO_PRODUTO(CP.CDFILICPLA, CP.CDPRODCPLA, C_NRTPCUS.NRTIPOCUSTO, DECODE(PG.IDUTCARDPADR, 'S', CD.DTREFECUSTMES, CP.DTCONSPLAN), SYSDATE) * CP.QTCONSPLAN) AS CUSTOPLAN,
                                    0 AS CUSTOREAL,
                                    (CUSTO_PRODUTO(C_ETL.CDFILCENTPME, CP.CDPRODCPLA, C_NRTPCUS.NRTIPOCUSTO, DECODE(PG.IDUTCARDPADR, 'S', CD.DTREFECUSTMES, CP.DTCONSPLAN), SYSDATE) * CP.QTCONSPLAN) AS CUSTOPLANCENT,
                                    0 AS CUSTOREALCENT,
                                    CP.CDPRODCPLA CDPRODUTO
                                FROM
                                    CONSPLAN CP, PARAMGERAL PG,
                                    (SELECT  CD.CDFILIAL, CD.CDSERVFILI, CD.DTMESCARD, MAX(CM.DTREFECUSTMES) DTREFECUSTMES
                                     FROM    CARDADIA CD, CARDAMES CM
                                     WHERE   CD.CDFILIAL       =    C_ETL.CDFILIAL       AND
                                             CD.CDSERVFILI     =    C_SERVICO.CDSERVFILI AND
                                             CD.DTCARDAPIO BETWEEN V_DTINI AND V_DTFIM   AND
                                             (CD.CDFILIAL   = CM.CDFILIAL     ) AND
                                             (CD.CDSERVFILI = CM.CDSERVFILI   ) AND
                                             (CD.DTMESCARD  = CM.DTMESCARDAPIO)
                                     GROUP BY CD.CDFILIAL, CD.CDSERVFILI, CD.DTMESCARD) CD
                                WHERE
                                    CP.CDFILICPLA   =  C_ETL.CDFILIAL              AND
                                    CP.NRCONSPLAN   =  V_CDSEQUENCIAL              AND
                                    CD.CDFILIAL     =  CP.CDFILICPLA               AND
                                    CD.CDSERVFILI   =  CP.CDSERVCPLA               AND
                                    PG.CDPARGERAL   = '0001'                       AND
                                    CD.DTMESCARD    = ADD_MONTHS(LAST_DAY(CP.DTCONSPLAN) + 1, -1)

                                UNION ALL

                               SELECT
                                    H.CDFILIAL, H.CDSERVFILI,
                                    ROUND(CNE.VRPLANNESTO * (RNE.PERATENESTO/100) * (CD.QTCOMESTICAR/H.TOTCOMEN), 5) AS CUSTOPLAN,
                                    0 AS CUSTOREAL,
                                                              /*CLCULO DA CENTRAL*/
                                    ROUND(CNE.VRPLANNESTO * (RNE.PERATENESTO/100) * (CD.QTCOMESTICAR/H.TOTCOMEN), 5) AS CUSTOPLANCENT,
                                    0 AS CUSTOREALCENT,
                                    CNE.CDPRODUTO AS CDPRODUTO
                                FROM
                                    (SELECT CDR.CDFILIAL,   CDR.CDSERVFILI,  CDR.DTMESCARD,
                                        SUM(QTCOMESTICAR) AS TOTCOMEN
                                     FROM CARDADIA CDR
                                     WHERE
                                        (CDR.CDFILIAL         =   C_ETL.CDFILIAL       ) AND
                                        (CDR.CDSERVFILI       =   C_SERVICO.CDSERVFILI ) AND
                                        (CDR.DTCARDAPIO BETWEEN   V_DTINI AND V_DTFIM )
                                     GROUP BY CDSERVFILI, CDR.CDFILIAL, CDR.CDSERVFILI, CDR.DTMESCARD
                                    ) H, RATENESTO RNE, CUSTNESTO CNE, CARDADIA  CD
                                WHERE
                                    (CD.CDFILIAL      =    C_ETL.CDFILIAL         )   AND
                                    (H.CDFILIAL       =    C_ETL.CDFILIAL         )   AND
                                    (CNE.CDFILIAL     =    C_ETL.CDFILIAL         )   AND
                                    (RNE.CDFILIAL     =    C_ETL.CDFILIAL         )   AND
                                    (CD.CDSERVFILI    =    C_SERVICO.CDSERVFILI   )   AND
                                    (H.CDSERVFILI     =    C_SERVICO.CDSERVFILI   )   AND
                                    (RNE.CDSERVFILI   =    C_SERVICO.CDSERVFILI   )   AND
                                    (CNE.CDPRODUTO    =    RNE.CDPRODUTO           )   AND
                                    (CD.DTMESCARD     =    H.DTMESCARD             )   AND
                                    (CD.DTCARDAPIO BETWEEN   V_DTINI AND V_DTFIM )   AND
                                    (NOT H.TOTCOMEN IS NULL AND H.TOTCOMEN <> 0 )

                                UNION ALL
         ------------------------------------------------/* CUSTO PLANEJADO MERENDA */
                                 SELECT
                                    CP.CDFILICPLA CDFILIAL,
                                    CP.CDSERVCPLA CDSERVFILI,
                                    (CUSTO_PRODUTO(CP.CDFILICPLA, CP.CDPRODCPLA, V_NRTIPOCUSTO1, DECODE(PG.IDUTCARDPADR, 'S', CD.DTREFECUSTMES, CP.DTCONSPLAN), SYSDATE) * CP.QTCONSPLAN) AS CUSTOPLAN,
                                    0 AS CUSTOREAL,
                                       /*CLCULO DA CENTRAL*/
                                    (CUSTO_PRODUTO(C_ETL.CDFILCENTPME, CP.CDPRODCPLA, V_NRTIPOCUSTO1, DECODE(PG.IDUTCARDPADR, 'S', CD.DTREFECUSTMES, CP.DTCONSPLAN), SYSDATE) * CP.QTCONSPLAN) AS CUSTOPLANCENT,
                                    0 AS CUSTOREALCENT,
                                    CP.CDPRODCPLA CDPRODUTO
                                FROM CONSPLAN CP, PARAMGERAL PG,  CARDIAPME CDI,
                                    (SELECT  CDFILIAL, CDSERVFILI, MAX(DTCARDIAPME) AS DTREFECUSTMES
                                       FROM    CARDIAPME
                                       WHERE   CDFILIAL       =    C_ETL.CDFILIAL       AND
                                              CDSERVFILI     =    C_SERVICO.CDSERVFILI AND
                                             DTCARDIAPME BETWEEN V_DTINI AND V_DTFIM
                                      GROUP BY CDFILIAL, CDSERVFILI ) CD
                                WHERE
                                    CP.CDFILICPLA    =  C_ETL.CDFILIAL              AND
                                    CP.NRCONSPLAN    =  V_CDSEQUENCIAL              AND
                                    CD.CDFILIAL      =  CP.CDFILICPLA               AND
                                    CD.CDSERVFILI    =  CP.CDSERVCPLA               AND
                                    PG.CDPARGERAL    = '0001'                       AND
                                    CDI.CDSERVFILI   =  CP.CDSERVCPLA               AND
                                    CDI.CDFILIAL     =  C_ETL.CDFILIAL              AND
                                    CDI.CDSERVFILI   =  C_SERVICO.CDSERVFILI        AND
                                    CDI.CDFILCENTPME =  CP.CDFILCENTPME             AND
                                    CDI.DTCARDIAPME   =  CP.DTCONSPLAN               AND
                                    CDI.DTCARDIAPME  BETWEEN V_DTINI AND V_DTFIM     

                                UNION ALL                  

                                SELECT
                                    C.CDFILIAL,
                                    C.CDSERVFILI,
                                    0 AS CUSTOPLAN,
                                    (C.QTRETIRADA * CUSTO_PRODUTO(C.CDFILIAL, C.CDPRODUTO, C_NRTPCUS.NRTIPOCUSTO, C.DTCARDAPIO, SYSDATE)) AS CUSTOREAL,
                                             /*CLCULO DA CENTRAL*/
                                    0 AS CUSTOPLANCENT,
                                    (C.QTRETIRADA * CUSTO_PRODUTO(C_ETL.CDFILCENTPME, C.CDPRODUTO, C_NRTPCUS.NRTIPOCUSTO, C.DTCARDAPIO, SYSDATE)) AS CUSTOREALCENT,
                                    C.CDPRODUTO
                                FROM
                                    (SELECT
                                       CA.CDFILIAL,
                                       CA.CDSERVFILI,
                                       CA.DTCARDAPIO,
                                       SUM(IR.QTRETIRADA * PR.VRFATOCONV) AS QTRETIRADA,
                                       PR.CDPRODUTO
                                    FROM
                                       CARDADIA CA,
                                       PRODUTO  PR,
                                       ITEMRETI IR
                                    WHERE
                                       (IR.CDFILIAL       =     C_ETL.CDFILIAL       )   AND
                                       (CA.CDFILIAL       =     C_ETL.CDFILIAL       )   AND
                                       (CA.CDSERVFILI     =     C_SERVICO.CDSERVFILI )   AND
                                       (PR.CDPRODUTO      =     PR.CDPRODESTO         )   AND
                                       (PR.CDPRODUTO      =     IR.CDPRODUTO          )   AND
                                       (CA.CDFILIAL       =     IR.CDFILIAL           )   AND
                                       (IR.NRCARDAPIO     =     CA.NRCARDAPIO         )   AND
                                       (CA.DTCARDAPIO BETWEEN V_DTINI AND V_DTFIM   )
                                    GROUP BY CA.CDFILIAL, CA.CDSERVFILI, CA.DTCARDAPIO, PR.CDPRODUTO) C

                                UNION ALL

                                SELECT
                                    CA.CDFILIAL, CA.CDSERVFILI,
                                    0 AS CUSTOPLAN,
                                    ROUND(CNE.VRREALNESTO * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5) AS CUSTOREAL,                      /*CLCULO DA CENTRAL*/

                                    0 AS CUSTOPLANCENT,
                                    ROUND(CNE.VRREALNESTO * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5) AS CUSTOREALCENT,
                                    CNE.CDPRODUTO
                                FROM
                                    (SELECT DTMESCARD, CDSERVFILI,
                                        SUM(QTCOMEFETCAR) AS TOTCOMEN
                                     FROM CARDADIA CDR
                                     WHERE
                                        (CDR.CDFILIAL      = C_ETL.CDFILIAL        )     AND
                                        (CDR.CDSERVFILI    = C_SERVICO.CDSERVFILI  )     AND
                                        (DTCARDAPIO BETWEEN  V_DTINI AND V_DTFIM  )
                                     GROUP BY
                                        DTMESCARD,
                                        CDSERVFILI
                                     ) TC,
                                    CARDADIA  CA,
                                    RATENESTO RNE,
                                    CUSTNESTO CNE
                                WHERE
                                    (CA.DTCARDAPIO BETWEEN  V_DTINI AND V_DTFIM  )  AND
                                    (CA.CDFILIAL         =  C_ETL.CDFILIAL        )  AND
                                    (RNE.CDFILIAL        =  C_ETL.CDFILIAL        )  AND
                                    (CNE.CDFILIAL        =  C_ETL.CDFILIAL        )  AND
                                    (RNE.CDSERVFILI      =  C_SERVICO.CDSERVFILI  )  AND
                                    (CA.CDSERVFILI       =  C_SERVICO.CDSERVFILI  )  AND
                                    (CA.CDSERVFILI       =  RNE.CDSERVFILI         )  AND
                                    (RNE.CDPRODUTO       =  CNE.CDPRODUTO          )  AND
                                    (TC.DTMESCARD        =  CA.DTMESCARD           )  AND
                                    (NOT TC.TOTCOMEN IS NULL AND TC.TOTCOMEN <> 0  )  AND
                                    (NOT CNE.VRREALNESTO IS NULL                   )  AND
                                    (TO_CHAR(CA.DTCARDAPIO, 'MMYYYY') = TO_CHAR(CNE.DTCUSTNESTO, 'MMYYYY'))

                                UNION ALL

                                SELECT
                                    RNE.CDFILIAL,
                                    RNE.CDSERVFILI,
                                    0 AS CUSTOPLAN,
                                    ROUND(TCN.VRTOTAITEM * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5) AS CUSTOREAL,

                                             /*CLCULO DA CENTRAL*/

                                    0 AS CUSTOPLANCENT,
                                    ROUND(TCN.VRTOTAITEM * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5) AS CUSTOREALCENT,
                                    TCN.CDPRODUTO
                                FROM RATENESTO   RNE, CARDADIA    CA,
                                    (
                                    SELECT
                                        DTMESCARD,         CDSERVFILI,
                                        SUM(QTCOMEFETCAR) AS TOTCOMEN
                                     FROM CARDADIA CDR
                                     WHERE
                                        (CDR.CDFILIAL     = C_ETL.CDFILIAL       ) AND
                                        (CDR.CDSERVFILI   = C_SERVICO.CDSERVFILI ) AND
                                        (DTCARDAPIO BETWEEN V_DTINI AND V_DTFIM )
                                     GROUP BY DTMESCARD, CDSERVFILI ) TC,
                                     (
                                     SELECT
                                         TO_CHAR(NF.DTENTRSAID, 'MMYYYY') AS DTMESNF,
                                         IP.CDPRODUTO,
                                         SUM(IP.VRTOTAITEM) AS VRTOTAITEM
                                      FROM NOTAFISCAL  NF, ITEMPRODUTO IP
                                      WHERE
                                        (NF.IDENTRSAIDOP     =     'E'                   )  AND
                                        (IP.CDFILIAL         =     NF.CDFILIAL           )  AND
                                        (IP.NRLANCTONF       =     NF.NRLANCTONF         )  AND
                                        (NF.CDFILIAL         =     C_ETL.CDFILIAL       )  AND
                                        (IP.CDFILIAL         =     C_ETL.CDFILIAL       )  AND
                                        (NF.DTENTRSAID BETWEEN V_DTINI AND V_DTFIM     )
                                      GROUP BY
                                         TO_CHAR(NF.DTENTRSAID, 'MMYYYY'),
                                         IP.CDPRODUTO) TCN
                                WHERE
                                    (CA.CDFILIAL         =      C_ETL.CDFILIAL       ) AND
                                    (RNE.CDFILIAL        =      C_ETL.CDFILIAL       ) AND
                                    (CA.CDFILIAL         =      RNE.CDFILIAL          ) AND
                                    (CA.CDSERVFILI       =      C_SERVICO.CDSERVFILI ) AND
                                    (RNE.CDSERVFILI      =      C_SERVICO.CDSERVFILI ) AND
                                    (TCN.CDPRODUTO       =      RNE.CDPRODUTO         ) AND
                                    (TC.DTMESCARD        =      CA.DTMESCARD          ) AND
                                    (TC.CDSERVFILI       =      CA.CDSERVFILI         ) AND
                                    (NOT TC.TOTCOMEN IS NULL AND TC.TOTCOMEN <> 0     ) AND
                                    (CA.DTCARDAPIO BETWEEN V_DTINI AND V_DTFIM      ) AND
                                    (TO_CHAR(CA.DTCARDAPIO, 'MMYYYY') = TCN.DTMESNF   ) AND
                                    (NOT EXISTS (SELECT CDFILIAL
                                                 FROM  CUSTNESTO
                                                 WHERE
                                                        CDFILIAL         =     C_ETL.CDFILIAL  AND
                                                        DTCUSTNESTO      =     CA.DTCARDAPIO    AND
                                                        CDPRODUTO        =     RNE.CDPRODUTO    AND
                                                        NOT VRREALNESTO IS NULL))) PR
                               WHERE
                                    (SVC.CDFILIAL       =       C_ETL.CDFILIAL      )  AND
                                    (SVC.CDSERVFILI     =       C_SERVICO.CDSERVFILI)  AND
                                    (SVC.CDGRUPSERV     =      GPS.CDGRUPSERV (+)   )  AND
                                    (SVC.CDFILIAL       =      PR.CDFILIAL          )  AND
                                    (SVC.CDSERVFILI     =      PR.CDSERVFILI        )
                               GROUP BY PR.CDFILIAL, PR.CDSERVFILI, GPS.CDGRUPSERV, PR.CDPRODUTO) LOOP

                           INSERT INTO ETL_RESUFOOD
                              ( CDFILIAL,              CDAREAGERE,             CDSUPERVISOR,
                              CDGOPERAC,             CDEMPRESA,              CDSEGMER,
                              CDPRODUTO,             CDANOBI,                CDMESBI,
                              BIETLFOOD,             TRETLFOOD,              SEETLFOOD,
                              CDGRUPSERV,            CDFILISERVFILI,         CDETLFILCENTPME,
                              VRCUSPLACENTFOO,       VRCUSREACENTFOO,        VRCUSPLAFILIFOO,
                              VRCUSREAFILIFOO,       CDTIPOCUSTO)
                           VALUES
                              (C_ETL.CDFILIAL,        C_ETL.CDAREAGERE,       C_ETL.CDSUPERVISOR,
                              C_ETL.CDGOPERAC,       C_ETL.CDEMPRESA,        C_ETL.CDSEGMER,
                              C_PRODUTO.CDPRODUTO,   V_ANO,                  V_MES,
                              V_BIM,                 V_TRI,                  V_SEM,
                              C_PRODUTO.CDGRUPSERV,  C_ETL.CDFILIAL||C_SERVICO.CDSERVFILI,
                              C_ETL.CDFILCENTPME,                 C_PRODUTO.CUSTOPLANCENT,
                              C_PRODUTO.CUSTOREALCENT,            C_PRODUTO.CUSTOPLAN,
                              C_PRODUTO.CUSTOREAL,                C_NRTPCUS.CDTIPOCUSTO);

                             V_COUNTER := V_COUNTER+1;
                             IF V_COUNTER >= 500 THEN
                                 COMMIT;
                                 V_COUNTER := 0;
                              END IF;
                     END LOOP;

                     INSERT INTO ETL_RESUSERV
                           (CDFILIAL,                  CDAREAGERE,
                           CDSUPERVISOR,              CDGOPERAC,
                           CDEMPRESA,                 CDSEGMER,
                           CDGRUPSERV,                CDFILISERVFILI,
                           CDANOBI,                   CDMESBI,
                           BIETLSERV,                 TRETLSERV,
                           SEETLSERV,                 QTCOMESTETLSERV,
                           QTCOMEFEETLSERV,           VRCUSPADETLSERV )
                        VALUES
                           (C_ETL.CDFILIAL,            C_ETL.CDAREAGERE,
                           C_ETL.CDSUPERVISOR,        C_ETL.CDGOPERAC,
                           C_ETL.CDEMPRESA,           C_ETL.CDSEGMER,
                           C_SERVICO.CDGRUPSERV,      C_ETL.CDFILIAL||C_SERVICO.CDSERVFILI,
                           V_ANO,                     V_MES,
                           V_BIM,                     V_TRI,
                           V_SEM,                     C_SERVICO.QTCOMESTICAR,
                           C_SERVICO.QTCOMEFETCAR,    V_VRCUSTPADR);

                     V_COUNTER := V_COUNTER+1;

                     IF V_COUNTER >= 500 THEN
                        COMMIT;
                        V_COUNTER := 0;
                     END IF;
                 END LOOP;
                 DELETE FROM CONSPLAN
                 WHERE NRCONSPLAN = V_CDSEQUENCIAL;
            END IF;
          END LOOP;
            COMMIT;
            V_DTINI := ADD_MONTHS(V_DTINI,1);
         END LOOP;

      END LOOP;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ETL_MERENDA','5.01.008'); END;
/
