import Vue from 'vue';
import Router from 'vue-router';
import { components } from '@zeedhi/vuetify';

const { ZdFramePage } = components;

Vue.use(Router);

const router = new Router({
  mode: 'history',
  base: process.env.BASE_URL,
  routes: [
    {
      path: '/',
      name: 'home',
      component: () => import('./views/Home.vue'),
    },
    {
      path: '/zeedhi',
      name: 'zeedhi',
      component: ZdFramePage,
      props: () => ({
        path: 'zeedhi',
        local: true,
      }),
    },
    {
      path: '/parametrizacao',
      name: 'parametrizacao',
      component: ZdFramePage,
      props: () => ({
        path: 'layout_parametrizacao',
        local: true,
      }),
    },
    {
      path: '/ordemdeservico',
      name: 'ordemServico',
      component: ZdFramePage,
      props: () => ({
        path: 'layout_ordemServico',
        local: true,
      }),
    },
    {
      path: '/novaordemservico',
      name: 'novaordemservico',
      component: ZdFramePage,
      props: () => ({
        path: 'layout_novaOrdemServico',
        local: true,
      }),
    },
    {
      path: '/ordemservico',
      name: 'ordemservico',
      component: ZdFramePage,
      props: () => ({
        path: 'layout_visualizacaoOrdemServico',
        local: true,
      }),
    },
    {
      path: '/converterSolicitacaoEmOrdem',
      name: 'converterSolicitacaoEmOrdem',
      component: ZdFramePage,
      props: () => ({
        path: 'layout_converterEmOrdemServico',
        local: true,
      }),
    },
    {
      path: '/login',
      name: 'login',
      component: ZdFramePage,
      props: () => ({
        path: 'login',
        local: true,
      }),
    },
    {
      path: '/ativosInsumos',
      name: 'Ativos, Categoria e Insumos',
      component: ZdFramePage,
      props: () => ({
        path: 'layout_ativosInsumos',
        local: true,
      }),
    },
    {
      path: '/ativos',
      name: 'Detalhes de Ativos',
      component: ZdFramePage,
      props: () => ({
        path: 'layout_ativos',
        local: true,
      }),
    },
    {
      path: '/dashboardServico',
      name: 'Dashbord de Serviço',
      component: ZdFramePage,
      props: () => ({
        path: 'layout_dashboardDeServico',
        local: true,
      }),
    },
    {
      path: '/solicitacoes',
      name: 'lista de solicitações de serviço',
      component: ZdFramePage,
      props: () => ({
        path: 'layout_solicitacoesDeServico',
        local: true,
      }),
    },
    {
      path: '/solicitacao',
      name: 'Detalhes da solicitação de serviço',
      component: ZdFramePage,
      props: () => ({
        path: 'layout_solicitacao',
        local: true,
      }),
    },
    {
      path: '/insumosDeAtivos',
      name: 'Detalhes de insumos para manutenção de Ativos',
      component: ZdFramePage,
      props: () => ({
        path: 'layout_insumosDeAtivos',
        local: true,
      }),
    },
    {
      path: '*',
      component: ZdFramePage,
      props: {
        path: 'notfound',
        local: true,
      },
    },
    {
      path: '/Dashboard',
      name: 'dashboard',
      component: ZdFramePage,
      props: {
        path: 'dashboard',
        local: true,
      },
    },
  ],
});

export default router;
